Attribute VB_Name = "FastBlit"

'FastBlit.bas
'by David Finch 11-29-2000
'Updated 12-03-2000
'Quickly draws the contents of an array of 32bit,16bit, or
'15bit color values to a picturebox, stretching if necessary.
'Written in VB6, but should work in VB4 and VB5 as well.

'You are free to use FastBlit in your own programs as
'long as you list my name in the "Special Thanks."

DefLng A-Z
Option Explicit

Private Declare Function CreateDIBSection Lib "gdi32" (ByVal hDC As Long, pBitmapInfo As BITMAPINFO, ByVal un As Long, ByRef lplpVoid As Long, ByVal handle As Long, ByVal dw As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Function StretchBlt Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Long, ByRef Source As Any, ByVal Length As Long)
Private Declare Sub CopyMemory2 Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Type BITMAPINFOHEADER '40 bytes
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Private Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColor0 As Long
        bmiColor1 As Long
        bmiColor2 As Long
End Type

Private dibWidth, dibHeight
Private dc
Private dib
Private dptr
Private bpp

Public Sub Blit(buffer(), pic As PictureBox, imageWidth, imageHeight)
    If imageWidth = 0 Or imageHeight = 0 Then Exit Sub
    If dibWidth <> imageWidth Or dibHeight <> imageHeight Or bpp <> 32 Then
        Dim bi As BITMAPINFO
        If dc <> 0 Then DeleteDC dc
        If dib <> 0 Then DeleteObject dib
        dibWidth = imageWidth
        dibHeight = imageHeight
        With bi.bmiHeader
            .biWidth = dibWidth
            .biHeight = -dibHeight
            .biSize = 40
            .biBitCount = 32
            .biPlanes = 1
        End With
        dc = CreateCompatibleDC(0)
        If dc = 0 Then Exit Sub
        dib = CreateDIBSection(dc, bi, 0, dptr, 0, 0)
        If dib = 0 Then MsgBox "CreateDIBSection 32 Failed"
        SelectObject dc, dib
    End If
    If dib <> 0 And dc <> 0 Then
        CopyMemory dptr, buffer(0), dibWidth * dibHeight * 4
        If pic.ScaleMode <> 3 Then pic.ScaleMode = 3
        StretchBlt pic.hDC, 0, 0, pic.ScaleWidth, pic.ScaleHeight, dc, 0, 0, dibWidth, dibHeight, vbSrcCopy
    End If
    bpp = 32
End Sub

Public Sub blit15(buffer() As Integer, pic As PictureBox, imageWidth, imageHeight)
    If imageWidth = 0 Or imageHeight = 0 Then Exit Sub
    If dibWidth <> imageWidth Or dibHeight <> imageHeight Or bpp <> 15 Then
        Dim bi As BITMAPINFO
        If dc <> 0 Then DeleteDC dc
        If dib <> 0 Then DeleteObject dib
        dibWidth = imageWidth
        dibHeight = imageHeight
        With bi.bmiHeader
            .biWidth = dibWidth
            .biHeight = -dibHeight
            .biSize = 40
            .biBitCount = 16
            .biPlanes = 1
        End With
        dc = CreateCompatibleDC(0)
        If dc = 0 Then Exit Sub
        dib = CreateDIBSection(dc, bi, 0, dptr, 0, 0)
        If dib = 0 Then MsgBox "CreateDIBSection 15 Failed"
        SelectObject dc, dib
    End If
    If dib <> 0 And dc <> 0 Then
        CopyMemory dptr, buffer(0), dibWidth * dibHeight * 2
        If pic.ScaleMode <> 3 Then pic.ScaleMode = 3
        StretchBlt pic.hDC, 0, 0, pic.ScaleWidth, pic.ScaleHeight, dc, 0, 0, dibWidth, dibHeight, vbSrcCopy
    End If
    bpp = 15
End Sub

Public Sub blit16(buffer() As Integer, pic As PictureBox, imageWidth, imageHeight)
    If imageWidth = 0 Or imageHeight = 0 Then Exit Sub
    If dibWidth <> imageWidth Or dibHeight <> imageHeight Or bpp <> 16 Then
        Dim bi As BITMAPINFO
        If dc <> 0 Then DeleteDC dc
        If dib <> 0 Then DeleteObject dib
        dibWidth = imageWidth
        dibHeight = imageHeight
        With bi.bmiHeader
            .biWidth = dibWidth
            .biHeight = -dibHeight
            .biSize = 40
            .biBitCount = 16
            .biPlanes = 1
            .biCompression = 3
        End With
        bi.bmiColor0 = &HF800&
        bi.bmiColor1 = &H7E0&
        bi.bmiColor2 = &H1F&
        dc = CreateCompatibleDC(0)
        If dc = 0 Then Exit Sub
        dib = CreateDIBSection(dc, bi, 0, dptr, 0, 0)
        If dib = 0 Then MsgBox "CreateDIBSection 16 Failed"
        SelectObject dc, dib
    End If
    If dib <> 0 And dc <> 0 Then
        CopyMemory dptr, buffer(0), dibWidth * dibHeight * 2
        If pic.ScaleMode <> 3 Then pic.ScaleMode = 3
        StretchBlt pic.hDC, 0, 0, pic.ScaleWidth, pic.ScaleHeight, dc, 0, 0, dibWidth, dibHeight, vbSrcCopy
    End If
    bpp = 16
End Sub

'Pretty simple, plots a point and sees how the color is approximated
Public Function getColorDepth(p As PictureBox)
    p.PSet (0, 0), &H151515
    Select Case p.Point(0, 0)
    Case &H181418
        getColorDepth = 16
    Case &H181818
        getColorDepth = 15
    Case Else
        getColorDepth = 32
    End Select
End Function

Public Sub CleanUp() 'very important
    If dc <> 0 Then DeleteDC dc
    If dib <> 0 Then DeleteObject dib
End Sub
