Attribute VB_Name = "MMC"
Option Explicit


DefLng A-Z


' Functions for emulating MMCs. Select8KVROM and the
' like
' 16.07.00
Public CurrVr As Byte
Public PrgSwitch1 As Byte
Public PrgSwitch2 As Byte
Public SpecialWrite6000 As Boolean

Public bank0(2047) As Byte ' RAM
Public bank6(8191) As Byte ' SaveRAM
Public bank8(8191) As Byte '8-E are PRG-ROM.
Public bankA(8191) As Byte
Public bankC(8191) As Byte
Public bankE(8191) As Byte

'the mappers try to only switch banks when necessary. The following helps it to ignore most unnecessary bankswitches
'The following vars store addresses, so that if a game switches to a bank that's already loaded in that slot, it will be able to avoid copying data over itself
Private pval8 As Long
Private pval4(1) As Long
Private pval2(3) As Long
Private pval1(7) As Long
Public pTablesWritten As Boolean




Public Sub MMC3_Sync()
If swap Then
    reg8 = &HFE
    regA = PrgSwitch2
    regC = PrgSwitch1
    regE = &HFF
Else
    reg8 = PrgSwitch1
    regA = PrgSwitch2
    regC = &HFE
    regE = &HFF
End If
SetupBanks
End Sub

Public Function MaskBankAddress(bank As Byte)
If bank >= PrgCount * 2 Then
Dim i As Byte: i = &HFF
Do While (bank And i) >= PrgCount * 2
    i = i \ 2
Loop
MaskBankAddress = (bank And i)
Else
MaskBankAddress = bank
End If
End Function
Public Function MaskVROM(page As Byte, mask As Byte) As Byte
    MaskVROM = (page And (mask - 1))
End Function

'only switches banks when needed
Public Sub SetupBanks()

    reg8 = MaskBankAddress(reg8)
    regA = MaskBankAddress(regA)
    regC = MaskBankAddress(regC)
    regE = MaskBankAddress(regE)
    
    MemCopy bank8(0), gameImage(reg8 * &H2000&), &H2000&
    MemCopy bankA(0), gameImage(regA * &H2000&), &H2000&
    MemCopy bankC(0), gameImage(regC * &H2000&), &H2000&
    MemCopy bankE(0), gameImage(regE * &H2000&), &H2000&
End Sub
Public Sub Select8KVROM(val1 As Byte)
    val1 = MaskVROM(val1, ChrCount)
    MemCopy VRAM(0), VROM(val1 * &H2000&), &H2000&
End Sub
Public Sub Select4KVROM(val1 As Byte, bank As Byte)
    val1 = MaskVROM(val1, ChrCount * 2)
    MemCopy VRAM(bank * &H1000&), VROM(val1 * &H1000&), &H1000&
End Sub
Public Sub Select2KVROM(val1 As Byte, bank As Byte)
    val1 = MaskVROM(val1, ChrCount * 4)
    If Mapper = 4 Then
        MemCopy VRAM(MMC3_ChrAddr Xor (bank * &H800&)), VROM(val1 * &H800&), &H800&
    Else
        MemCopy VRAM(bank * &H800&), VROM(val1 * &H800&), &H800&
    End If
End Sub
Public Sub Select1KVROM(val1 As Byte, bank As Byte)
    val1 = MaskVROM(val1, ChrCount * 8)
    If Mapper = 4 Then
        MemCopy VRAM(MMC3_ChrAddr Xor (bank * &H400&)), VROM(val1 * &H400&), &H400&
    Else
        MemCopy VRAM(bank * &H400&), VROM(val1 * &H400&), &H400&
    End If
End Sub
