Attribute VB_Name = "NESHardware"
'+====================================================+'
'| basicNES 2k                                        |'
'| by Don Jarrett, 2000                               |'
'| Big portions of graphics code done by David Finch. |'
'| Always a source/binary release                     |'
'| http://home.att.net/~r.jarrett/bNES.html           |'
'+====================================================+'

Option Explicit ' Option Explicit is important for avoiding mysterious, crippling bugs

DefLng A-Z 'this ensures that no variants are used unless we choose so

Public EmphVal As Integer

Public romName As String

'DF: array to draw each frame to
Public vBuffer(256& * 241& - 1) As Byte '256*241 to allow for some overflow

Public vBuffer16(256& * 240& - 1) As Integer
Public vBuffer32(256& * 240& - 1) As Long

Public tLook(65536 * 8 - 1) As Byte


'DF: powers of 2
Public pow2(31) As Long

Public tilebased As Boolean

' NES Hardware defines
Public PPU_Control1 As Byte ' $2000
Public PPU_Control2 As Byte ' $2001
Public PPU_Status As Byte ' $2002
Public SpriteAddress As Long ' $2003
Public PPUAddressHi As Long ' $2006, 1st write
Public PPUAddress As Long ' $2006
Public PPU_AddressIsHi As Boolean
Public VRAM(&H3FFF) As Byte, VROM() As Byte  ' Video RAM
Public SpriteRAM(&HFF) As Byte

Public Sound(0 To &H15) As Byte
Public SoundCtrl As Byte

Public PrgCount As Byte, PrgCount2 As Long, ChrCount As Byte, ChrCount2 As Long

Public reg8 As Byte
Public regA As Byte
Public regC As Byte
Public regE As Byte

Public NESPal(&HF) As Byte

Public CPal() As Long

Public FrameSkip As Long 'Integer
Public Frames As Long

Public ScrollToggle As Byte
Public HScroll As Byte, VScroll As Long 'Integer ' $2005

Public Map15_BankAddr As Byte
Public Map15_SwapReg As Byte

'DF: these variables were undefined and therefore local:
Public swap As Boolean
Public map15_swapaddr As Long

' MMC3[Mapper #4] infos
Public MMC3_Command As Byte
Public MMC3_PrgAddr As Byte
Public MMC3_ChrAddr As Integer
Public MMC3_IrqVal As Byte
Public MMC3_TmpVal As Byte
Public MMC3_IrqOn As Boolean

Public PatternTable As Long
Public NameTable As Long

Public bank_regs(16) As Byte

Public Const PPU_InVBlank = &H80
Public Const PPU_Sprite0 = &H40
Public Const PPU_SpriteCount = &H20
Public Const PPU_Ignored = &H10

Public reg8000 As Byte ' Needed for mapper #69.

Public AndIt As Byte, AndIt2 As Byte

Public data(4) As Byte, sequence As Long 'Integer
Public accumulator As Long 'Integer

Public render As Boolean

Public Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
Public OpenFile As OPENFILENAME

Public ChrCnt As Byte, PrgCnt As Byte
Public FirstRead As Boolean ' First read to $2007 is invalid
Public Joypad1(7) As Byte, Joypad1_Count As Byte
Public Joypad2(7) As Byte, Joypad2_Count As Byte

Public Mapper As Byte, Mirroring As Byte, Trainer As Byte, FourScreen As Byte
Public MirrorXor As Long 'Integer
Public UsesSRAM As Boolean

Public Keyboard(255) As Byte

Public CPURunning As Boolean

Public Declare Sub MemCopy Lib "kernel32" Alias "RtlMoveMemory" (Dest As Any, Src As Any, ByVal cb&)

Public MMC32_Switch As Byte

Public MMC16_Irq As Long 'Integer
Public MMC16_IrqOn As Byte

'outdated code
Public Type Sprite
    x As Integer
    Y As Integer
    tileno As Byte
    attrib As Byte
End Type
Public SpriteAddr As Long 'Integer

Public pal(255) As Long
Public pal16(255) As Integer
Public pal15(255) As Integer

'Public Sprites(63) As Sprite

Public Mapper40_IRQEnabled As Byte, Mapper40_IRQCounter As Byte

Public latch1 As Byte, latch2 As Byte
Public Latch0FD As Byte, Latch0FE As Byte
Public Latch1FD As Byte, Latch1FE As Byte

' Other
Public Const VERSION = "basicNES 2000 v1.1 [debug level 1]"

'Fills color lookup table
Public Sub fillTLook()
    Dim b1, b2, c, x
    For b1 = 0 To 255
    For b2 = 0 To 255
        For x = 0 To 7
            If b1 And pow2(x) Then c = 1 Else c = 0
            If b2 And pow2(x) Then c = c + 2
            tLook(b1 * 2048 + b2 * 8 + x) = c
        Next x
    Next b2, b1
End Sub

Public Sub blitScreen()
    'Lets you know what type of mirroring is being used
    Select Case Mirroring
    Case 0
        frmNES.lbMirror.Caption = "|"
    Case 1
        frmNES.lbMirror.Caption = "-"
    Case 2
        frmNES.lbMirror.Caption = "+"
    End Select
    
    'Involves converting to high or true color.
    'Could be sped up if you took time to figure out palette animation in windows.
    Dim i
    Dim p16(31) As Integer
    Dim p32(31) As Long
    Static colorDepth
    If colorDepth = 0 Or (Frames And 63) = 0 Then colorDepth = getColorDepth(frmNES.picScreen)
    Select Case colorDepth
    Case 16
        For i = 0 To 31
            p16(i) = pal16(VRAM(i + &H3F00))
        Next i
        For i = 0 To 61439
            vBuffer16(i) = p16(vBuffer(i))
        Next i
        blit16 vBuffer16, frmNES.picScreen, 256, 240
    Case 15
        For i = 0 To 31
            p16(i) = pal15(VRAM(i + &H3F00))
        Next i
        For i = 0 To 61439
            vBuffer16(i) = p16(vBuffer(i))
        Next i
        blit15 vBuffer16, frmNES.picScreen, 256, 240
    Case Else
        For i = 0 To 31
            p32(i) = pal(VRAM(i + &H3F00))
        Next i
        For i = 0 To 61439
            vBuffer32(i) = p32(vBuffer(i))
        Next i
    
        Blit vBuffer32, frmNES.picScreen, 256, 240
    End Select

End Sub

'Accidentally included a few things twice, but fixing would make old saved states useless
Public Sub saveState(Index As Long)
    Dim f As String
    f = romName + ".sv" + CStr(Index)
    Open "nessave.tmp" For Binary As #1
    'delete f
    'Open f For Binary As #1
    Put #1, , VRAM
    Put #1, , SpriteRAM
    Put #1, , AddressMask
    Put #1, , a
    Put #1, , x
    Put #1, , Y
    Put #1, , S
    Put #1, , p
    Put #1, , PC
    Put #1, , savepc
    Put #1, , value
    Put #1, , value2
    Put #1, , sum
    Put #1, , saveflags
    Put #1, , CurrVr
    Put #1, , PrgSwitch1
    Put #1, , PrgSwitch2
    Put #1, , SpecialWrite6000
    Put #1, , bank0
    Put #1, , bank6
    Put #1, , Mapper40_IRQEnabled
    Put #1, , Mapper40_IRQCounter
    Put #1, , ChrCnt
    Put #1, , PrgCnt
    Put #1, , FirstRead
    Put #1, , Joypad1
    Put #1, , Joypad1_Count
    Put #1, , Joypad2
    Put #1, , Joypad2_Count
    Put #1, , Mapper
    Put #1, , Mirroring
    Put #1, , Trainer
    Put #1, , FourScreen
    Put #1, , MirrorXor
    Put #1, , UsesSRAM
    Put #1, , ScrollToggle
    Put #1, , HScroll
    Put #1, , VScroll
    Put #1, , Map15_BankAddr
    Put #1, , Map15_SwapReg
    Put #1, , swap
    Put #1, , map15_swapaddr
    Put #1, , MMC3_Command
    Put #1, , MMC3_PrgAddr
    Put #1, , MMC3_ChrAddr
    Put #1, , MMC3_IrqVal
    Put #1, , MMC3_TmpVal
    Put #1, , MMC3_IrqOn
    Put #1, , PatternTable
    Put #1, , NameTable
    Put #1, , bank_regs
    Put #1, , reg8000
    Put #1, , AndIt
    Put #1, , AndIt2
    Put #1, , data
    Put #1, , sequence
    Put #1, , accumulator
    Put #1, , PPU_Control1
    Put #1, , PPU_Control2
    Put #1, , PPU_Status
    Put #1, , SpriteAddress
    Put #1, , PPUAddressHi
    Put #1, , PPUAddress
    Put #1, , PPU_AddressIsHi
    Put #1, , Sound
    Put #1, , PrgCount
    Put #1, , PrgCount2
    Put #1, , ChrCount
    Put #1, , ChrCount2
    Put #1, , reg8
    Put #1, , regA
    Put #1, , regC
    Put #1, , regE
    Put #1, , CurrentLine
    Put #1, , VRAM
    Put #1, , SpriteRAM
    Put #1, , AddressMask
    Put #1, , a
    Put #1, , x
    Put #1, , Y
    Put #1, , S
    Put #1, , p
    Put #1, , PC
    Put #1, , savepc
    Put #1, , value
    Put #1, , value2
    Put #1, , sum
    Put #1, , saveflags
    Put #1, , CurrVr
    Put #1, , PrgSwitch1
    Put #1, , PrgSwitch2
    Put #1, , SpecialWrite6000
    Put #1, , Mapper40_IRQEnabled
    Put #1, , Mapper40_IRQCounter
    Put #1, , ChrCnt
    Put #1, , PrgCnt
    Put #1, , FirstRead
    Put #1, , Joypad1
    Put #1, , Joypad1_Count
    Put #1, , Joypad2
    Put #1, , Joypad2_Count
    Put #1, , Mapper
    Put #1, , Mirroring
    Put #1, , Trainer
    Put #1, , FourScreen
    Put #1, , MirrorXor
    Put #1, , UsesSRAM
    Put #1, , ScrollToggle
    Put #1, , HScroll
    Put #1, , VScroll
    Put #1, , Map15_BankAddr
    Put #1, , Map15_SwapReg
    Put #1, , swap
    Put #1, , map15_swapaddr
    Put #1, , MMC3_Command
    Put #1, , MMC3_PrgAddr
    Put #1, , MMC3_ChrAddr
    Put #1, , MMC3_IrqVal
    Put #1, , MMC3_TmpVal
    Put #1, , MMC3_IrqOn
    Put #1, , PatternTable
    Put #1, , NameTable
    Put #1, , bank_regs
    Put #1, , reg8000
    Put #1, , AndIt
    Put #1, , AndIt2
    Put #1, , data
    Put #1, , sequence
    Put #1, , accumulator
    Put #1, , PPU_Control1
    Put #1, , PPU_Control2
    Put #1, , PPU_Status
    Put #1, , SpriteAddress
    Put #1, , PPUAddressHi
    Put #1, , PPUAddress
    Put #1, , PPU_AddressIsHi
    Put #1, , Sound
    Put #1, , PrgCount
    Put #1, , PrgCount2
    Put #1, , ChrCount
    Put #1, , ChrCount2
    Put #1, , reg8
    Put #1, , regA
    Put #1, , regC
    Put #1, , regE
    Put #1, , CurrentLine
    
    Close #1
    RLECompress "nessave.tmp", f
    delete "nessave.tmp"
End Sub

Public Sub loadState(Index As Long)
    Dim f As String
    f = romName + ".sv" + CStr(Index)
    RLEDecompress f, "nesload.tmp"
    Open "nesload.tmp" For Binary As #1
    'Open f For Binary As #1
    Get #1, , VRAM
    Get #1, , SpriteRAM
    Get #1, , AddressMask
    Get #1, , a
    Get #1, , x
    Get #1, , Y
    Get #1, , S
    Get #1, , p
    Get #1, , PC
    Get #1, , savepc
    Get #1, , value
    Get #1, , value2
    Get #1, , sum
    Get #1, , saveflags
    Get #1, , CurrVr
    Get #1, , PrgSwitch1
    Get #1, , PrgSwitch2
    Get #1, , SpecialWrite6000
    Get #1, , bank0
    Get #1, , bank6
    Get #1, , Mapper40_IRQEnabled
    Get #1, , Mapper40_IRQCounter
    Get #1, , ChrCnt
    Get #1, , PrgCnt
    Get #1, , FirstRead
    Get #1, , Joypad1
    Get #1, , Joypad1_Count
    Get #1, , Joypad2
    Get #1, , Joypad2_Count
    Get #1, , Mapper
    Get #1, , Mirroring
    Get #1, , Trainer
    Get #1, , FourScreen
    Get #1, , MirrorXor
    Get #1, , UsesSRAM
    Get #1, , ScrollToggle
    Get #1, , HScroll
    Get #1, , VScroll
    Get #1, , Map15_BankAddr
    Get #1, , Map15_SwapReg
    Get #1, , swap
    Get #1, , map15_swapaddr
    Get #1, , MMC3_Command
    Get #1, , MMC3_PrgAddr
    Get #1, , MMC3_ChrAddr
    Get #1, , MMC3_IrqVal
    Get #1, , MMC3_TmpVal
    Get #1, , MMC3_IrqOn
    Get #1, , PatternTable
    Get #1, , NameTable
    Get #1, , bank_regs
    Get #1, , reg8000
    Get #1, , AndIt
    Get #1, , AndIt2
    Get #1, , data
    Get #1, , sequence
    Get #1, , accumulator
    Get #1, , PPU_Control1
    Get #1, , PPU_Control2
    Get #1, , PPU_Status
    Get #1, , SpriteAddress
    Get #1, , PPUAddressHi
    Get #1, , PPUAddress
    Get #1, , PPU_AddressIsHi
    Get #1, , Sound
    Get #1, , PrgCount
    Get #1, , PrgCount2
    Get #1, , ChrCount
    Get #1, , ChrCount2
    Get #1, , reg8
    Get #1, , regA
    Get #1, , regC
    Get #1, , regE
    Get #1, , CurrentLine
    Get #1, , VRAM
    Get #1, , SpriteRAM
    Get #1, , AddressMask
    Get #1, , a
    Get #1, , x
    Get #1, , Y
    Get #1, , S
    Get #1, , p
    Get #1, , PC
    Get #1, , savepc
    Get #1, , value
    Get #1, , value2
    Get #1, , sum
    Get #1, , saveflags
    Get #1, , CurrVr
    Get #1, , PrgSwitch1
    Get #1, , PrgSwitch2
    Get #1, , SpecialWrite6000
    Get #1, , Mapper40_IRQEnabled
    Get #1, , Mapper40_IRQCounter
    Get #1, , ChrCnt
    Get #1, , PrgCnt
    Get #1, , FirstRead
    Get #1, , Joypad1
    Get #1, , Joypad1_Count
    Get #1, , Joypad2
    Get #1, , Joypad2_Count
    Get #1, , Mapper
    Get #1, , Mirroring
    Get #1, , Trainer
    Get #1, , FourScreen
    Get #1, , MirrorXor
    Get #1, , UsesSRAM
    Get #1, , ScrollToggle
    Get #1, , HScroll
    Get #1, , VScroll
    Get #1, , Map15_BankAddr
    Get #1, , Map15_SwapReg
    Get #1, , swap
    Get #1, , map15_swapaddr
    Get #1, , MMC3_Command
    Get #1, , MMC3_PrgAddr
    Get #1, , MMC3_ChrAddr
    Get #1, , MMC3_IrqVal
    Get #1, , MMC3_TmpVal
    Get #1, , MMC3_IrqOn
    Get #1, , PatternTable
    Get #1, , NameTable
    Get #1, , bank_regs
    Get #1, , reg8000
    Get #1, , AndIt
    Get #1, , AndIt2
    Get #1, , data
    Get #1, , sequence
    Get #1, , accumulator
    Get #1, , PPU_Control1
    Get #1, , PPU_Control2
    Get #1, , PPU_Status
    Get #1, , SpriteAddress
    Get #1, , PPUAddressHi
    Get #1, , PPUAddress
    Get #1, , PPU_AddressIsHi
    Get #1, , Sound
    Get #1, , PrgCount
    Get #1, , PrgCount2
    Get #1, , ChrCount
    Get #1, , ChrCount2
    Get #1, , reg8
    Get #1, , regA
    Get #1, , regC
    Get #1, , regE
    Get #1, , CurrentLine
    Close #1
    SetupBanks
    delete "nesload.tmp"
End Sub



'scanline based sprite rendering
Public Sub RenderSprites(Scanline As Long, topLayer As Boolean)
If (PPU_Control2 And 16) = 0 Then Exit Sub

Dim TileRow As Byte, TileYOffset As Long 'Integer
Dim TileCounter As Long 'Integer
Dim Color As Byte
Dim TileIndex As Byte, Byte1 As Byte, Byte2 As Byte
Dim addToCol As Long
Dim h As Byte
Dim minX As Long
Dim X1 As Long, y1 As Long
Dim ptable As Long

TileRow = Scanline \ 8
TileYOffset = Scanline And 7
If PPU_Control1 And &H20 Then
    h = 16
Else
    h = 8
End If
If PPU_Control1 And &H8 Then
    If h = 8 Then
        PatternTable = &H1000&
    End If
Else
    If h = 8 Then
        PatternTable = &H0
    End If
End If
If PPU_Control2 And &H8 Then minX = 0 Else minX = 8
Dim spr As Long 'Integer
Dim SpriteAddr As Integer
Dim i As Long, x As Long, a As Long, v As Long
Dim attr As Byte
i = Scanline * 256&
For spr = 63 To 0 Step -1
    SpriteAddr = 4 * spr
    y1 = SpriteRAM(SpriteAddr) + 1
    If y1 <= Scanline And y1 > Scanline - h Then
        attr = SpriteRAM(SpriteAddr + 2)
        If (attr And 32) = 0 Xor topLayer Then
            X1 = SpriteRAM(SpriteAddr + 3)
            If X1 >= minX Then
                If render And X1 < 248 Then
                    addToCol = &H10 + (attr And 3) * 4
                    
                    TileIndex = SpriteRAM(SpriteAddr + 1)
                    If Mapper = 9 Or Mapper = 10 Then
                        If PatternTable = &H0 Then
                            MMC2_latch TileIndex, False
                        ElseIf PatternTable = &H1000& Then
                            MMC2_latch TileIndex, True
                        End If
                    End If
                    If h = 16 Then
                        If TileIndex And 1 Then
                            PatternTable = &H1000
                            TileIndex = TileIndex Xor 1
                        Else
                            PatternTable = 0
                        End If
                    End If
                    If attr And 128 Then 'vertical flip
                        v = y1 - Scanline - 1
                    Else
                        v = Scanline - y1
                    End If
                    v = v And h - 1
                    If v >= 8 Then v = v + 8
                    Byte1 = VRAM(PatternTable + (TileIndex * 16) + v)
                    Byte2 = VRAM(PatternTable + (TileIndex * 16) + 8 + v)
                    'real sprite 0 detection
                    If spr = 0 And (PPU_Status And 64) = 0 Then
                        If attr And 64 Then 'horizontal flip
                            a = i + X1
                            For x = 0 To 7 'draw yellow block for now.
                                If Byte1 And pow2(x) Then Color = 1 Else Color = 0
                                If Byte2 And pow2(x) Then Color = Color + 2
                                If Color Then
                                    If vBuffer(a + x) <> 16 Then PPU_Status = PPU_Status Or 64
                                    vBuffer(a + x) = addToCol Or Color
                                End If
                            Next x
                        Else
                            a = i + X1 + 7
                            For x = 7 To 0 Step -1 'draw yellow block for now.
                                If Byte1 And pow2(x) Then Color = 1 Else Color = 0
                                If Byte2 And pow2(x) Then Color = Color + 2
                                If Color Then
                                    If vBuffer(a - x) <> 16 Then PPU_Status = PPU_Status Or 64
                                    vBuffer(a - x) = addToCol Or Color
                                End If
                            Next x
                        End If
                    Else
                        If attr And 64 Then 'horizontal flip
                            a = i + X1
                            For x = 0 To 7 'draw yellow block for now.
                                If Byte1 And pow2(x) Then Color = 1 Else Color = 0
                                If Byte2 And pow2(x) Then Color = Color + 2
                                If Color Then
                                    vBuffer(a + x) = addToCol Or Color
                                End If
                            Next x
                        Else
                            a = i + X1 + 7
                            For x = 7 To 0 Step -1 'draw yellow block for now.
                                If Byte1 And pow2(x) Then Color = 1 Else Color = 0
                                If Byte2 And pow2(x) Then Color = Color + 2
                                If Color Then
                                    vBuffer(a - x) = addToCol Or Color
                                End If
                            Next x
                        End If
                    End If
                End If
                'also set sprite 0 flag if we pass sprite 0
                If spr = 0 Then If Scanline = y1 + h - 1 Then PPU_Status = PPU_Status Xor &H40 'claim we hit sprite #0
            End If
        End If
    End If
Next spr
End Sub

'DF: Made massive optimizations
'DF: Renders background and sprites
Public Sub RenderScanline(Scanline As Long)
If Scanline > 239 Then Exit Sub
If Scanline < 8 Then PPU_Status = PPU_Status And &H3F
If Scanline = 239 Then PPU_Status = PPU_Status Or &H80
If Not render Then 'speed optimization when drawing skipped frame
    If (PPU_Control2 And 16) = 0 Then Exit Sub
    If PPU_Status And 64 Then Exit Sub
    If Scanline > SpriteRAM(0) + 8 Then PPU_Status = PPU_Status Or 64
    Exit Sub
End If

Dim TileRow As Byte, TileYOffset As Long 'Integer
Dim TileCounter As Long 'Integer
Dim Color As Long
Dim TileIndex As Byte, Byte1 As Byte, Byte2 As Byte
Dim LookUp As Byte, addToCol As Long
Dim pixel As Long 'Integer
Dim x As Long, a As Long ', c As Long, pc As Long, px As Long
Dim m As Long
Dim sc As Long
Dim atrtab As Long



If tilebased Then
    Dim h As Long
    If PPU_Control1 And &H20 Then h = 16 Else h = 8
    If (PPU_Status And 64) = 0 Then If Scanline > SpriteRAM(0) + h Then PPU_Status = PPU_Status Or 64
    
    If Scanline = 1 Then
        For x = 0 To 256& * 240 - 1
            vBuffer(x) = 16 'A
        Next x
        DrawSprites True
    End If
    If Scanline = 239 Then
        DrawSprites False
    End If
Else
    'clear row
    sc = Scanline * 256&
    For x = sc To sc + 255: vBuffer(x) = 16: Next x
    
    'draw background sprites
    RenderSprites Scanline, True
End If

sc = Scanline + VScroll

'draw background
TileRow = (sc \ 8) Mod 30
TileYOffset = sc And 7
If Scanline < 240 - VScroll Then
    NameTable = &H2000& + (&H400& * (PPU_Control1 And &H3))
Else
    NameTable = &H2000& + (&H400& * (PPU_Control1 And &H3)) Xor &H800
End If


atrtab = NameTable + &H3C0
PatternTable = (PPU_Control1 And &H10) * &H100&
For TileCounter = HScroll \ 8 To 31
    TileIndex = VRAM(NameTable + TileCounter + TileRow * 32)
    If Mapper = 9 Or Mapper = 10 Then
        If PatternTable = &H0 Then
            MMC2_latch TileIndex, False
        ElseIf PatternTable = &H1000& Then
            MMC2_latch TileIndex, True
        End If
    End If
    Byte1 = VRAM(PatternTable + TileIndex * 16 + TileYOffset)
    Byte2 = VRAM(PatternTable + TileIndex * 16 + 8 + TileYOffset)
    x = TileCounter * 8 - HScroll + 7
    If x < 7 Then m = x Else m = 7
    x = x + Scanline * 256&
    LookUp = VRAM(atrtab + TileCounter \ 4 + (TileRow \ 4) * &H8&)
    Select Case (TileCounter And 2) Or (TileRow And 2) * 2
        Case 0
            addToCol = LookUp * 4 And 12
        Case 2
            addToCol = LookUp And 12
        Case 4
            addToCol = LookUp \ 4 And 12
        Case 6
            addToCol = LookUp \ 16 And 12
    End Select
    a = Byte1 * 2048& + Byte2 * 8
    For pixel = m To 0 Step -1
        Color = tLook(a + pixel)
        If Color Then vBuffer(x - pixel) = Color Or addToCol
    Next pixel
Next TileCounter

If Scanline < 240 - VScroll Then
    NameTable = &H2000& + (&H400& * (PPU_Control1 And &H3)) Xor &H400
Else
    NameTable = &H2000& + (&H400& * (PPU_Control1 And &H3)) Xor &HC00
End If
atrtab = NameTable + &H3C0
For TileCounter = 0 To HScroll \ 8
    TileIndex = VRAM(NameTable + (TileCounter + TileRow * 32))
    If Mapper = 9 Or Mapper = 10 Then
        If PatternTable = &H0 Then
            MMC2_latch TileIndex, False
        ElseIf PatternTable = &H1000& Then
            MMC2_latch TileIndex, True
        End If
    End If
    Byte1 = VRAM(PatternTable + (TileIndex * 16) + TileYOffset)
    Byte2 = VRAM(PatternTable + (TileIndex * 16) + 8 + TileYOffset)
    x = TileCounter * 8 + 256 - HScroll + 7
    If x > 255 Then m = x - 255 Else m = 0
    x = x + Scanline * 256&
    LookUp = VRAM(atrtab + (TileCounter \ 4) + (TileRow \ 4) * &H8&)
    Select Case (TileCounter And 2) Or (TileRow And 2) * 2
        Case 0
            addToCol = LookUp * 4 And 12
        Case 2
            addToCol = LookUp And 12
        Case 4
            addToCol = LookUp \ 4 And 12
        Case 6
            addToCol = LookUp \ 16 And 12
    End Select
    a = Byte1 * 2048& + Byte2 * 8
    For pixel = 7 To m Step -1
        Color = tLook(a + pixel)
        If Color Then vBuffer(x - pixel) = (Color Or addToCol) Or EmphVal
    Next pixel
Next TileCounter

If Not tilebased Then
'draw foreground sprites
RenderSprites Scanline, False
End If
End Sub

'DF: reordered the the case's. Made address long (was variant).
Public Function Read6502(ByVal Address As Long) As Byte

Select Case Address
    Case &H0 To &H1FFF
        Read6502 = bank0(Address And &H7FF)
    Case &H8000& To &HFFFF&
        Select Case (Address And &HE000&)
            Case &H8000&: Read6502 = bank8(Address And &H1FFF&)
            Case &HA000&: Read6502 = bankA(Address And &H1FFF&)
            Case &HC000&: Read6502 = bankC(Address And &H1FFF&)
            Case &HE000&: Read6502 = bankE(Address And &H1FFF&)
        End Select
    Case &H2002
        Dim ret As Byte
        ret = PPU_Status
        PPU_AddressIsHi = True
        ScrollToggle = 0
        PPU_Status = PPU_Status And &H3F
        Read6502 = ret
    Case &H2004
        Read6502 = SpriteRAM(SpriteAddress)
        SpriteAddress = (SpriteAddress + 1) And &HFF
    Case &H2007
        PPUAddress = PPUAddress And &H3FFF&
        If Mapper = 9 Or Mapper = 10 Then
        If PPUAddress <= &H1FFF& Then
            If PPUAddress > &HFFF& Then
                MMC2_latch VRAM(PPUAddress), True
            Else
                MMC2_latch VRAM(PPUAddress), False
            End If
        End If
        End If
        If PPUAddress >= &H3F20 And PPUAddress <= &H3FFF Then
            Read6502 = VRAM(PPUAddress And &H3F1F)
        Else
            Read6502 = VRAM(PPUAddress)
        End If
        If FirstRead Then
            FirstRead = False
        Else
            FirstRead = True
            If (PPU_Control1 And &H4) Then
                PPUAddress = PPUAddress + 32
            Else
                PPUAddress = PPUAddress + 1
            End If
        End If
    Case &H4000& To &H4013&, &H4015&
        Read6502 = Sound(Address - &H4000&)
    Case &H4016
        Read6502 = Joypad1(Joypad1_Count)
        'DF: what does the And 24 do?
        Joypad1_Count = (Joypad1_Count + 1) And 7 ' And 24
    Case &H4017
        Read6502 = Joypad2(Joypad2_Count)
        Joypad2_Count = (Joypad2_Count + 1) And 7 ' And 24
    Case &H6000& To &H7FFF&
        If UsesSRAM Then
            Read6502 = bank6(Address And &H1FFF&)
        End If
End Select
End Function

'DF: reordered the the case's. Made address long (was variant).
Public Sub Write6502(ByVal Address As Long, ByVal value As Byte)
'=========================================='
'           Write6502(Address,value)       '
'   Used to write values to the 6502's mem '
' and Mappers.                             '
'=========================================='
Select Case Address
    Case &H0 To &H1FFF: bank0(Address And &H7FF) = value
    Case &H8000& To &HFFFF&: MapperWrite Address, value
    Case &H2000: PPU_Control1 = value
    Case &H2001
        PPU_Control2 = value
        EmphVal = (value And &HE0) * 2
    Case &H2003: SpriteAddress = value
    Case &H2004
        SpriteRAM(SpriteAddress) = value
        SpriteAddress = (SpriteAddress + 1) And &HFF
    Case &H2005
        If PPU_AddressIsHi Then
            HScroll = value
            PPU_AddressIsHi = False
        Else
            VScroll = value
            PPU_AddressIsHi = True
        End If
    Case &H2006
        If PPU_AddressIsHi Then
            PPUAddressHi = value * &H100&
            PPU_AddressIsHi = False
        Else
            PPUAddress = PPUAddressHi + value
            PPU_AddressIsHi = True
        End If
    Case &H2007
        'Debug.Print "PPUAddress:$" & Hex$(PPUAddress), "Value:$" & Hex$(value)
        PPUAddress = PPUAddress And &H3FFF&
        If Mapper = 9 Or Mapper = 10 Then
        If PPUAddress <= &H1FFF& Then
            If PPUAddress > &HFFF& Then
                MMC2_latch VRAM(PPUAddress), True
            Else
                MMC2_latch VRAM(PPUAddress), False
            End If
        End If
        End If
        If PPUAddress >= &H3F00& And PPUAddress <= &H3FFF Then
            VRAM(PPUAddress And &H3F1F) = value
            'VRAM((PPUAddress And &H3F1F) Or &H10) = value  'DF: All those ref's lied. The palettes don't mirror
        Else
            If (PPUAddress And &H3000&) = &H2000& Then
                VRAM(PPUAddress Xor MirrorXor) = value
            End If
            VRAM(PPUAddress) = value
        End If
        If (PPU_Control1 And &H4) Then
            PPUAddress = PPUAddress + 32
        Else
            PPUAddress = PPUAddress + 1
        End If
    Case &H4000& To &H4013&
        Sound(Address - &H4000&) = value
        Dim n
        n = (Address - &H4000&) \ 4
        If n < 4 Then ChannelWrite(n) = True
    Case &H4014: 'DF: changed gameImage to bank0. This should work
        MemCopy SpriteRAM(0), bank0(value * &H100&), &H100&
    Case &H4015&: SoundCtrl = value 'Sound(Address - &H4000&) = value
    Case &H4016: Joypad1_Count = &H0
    Case &H4017: Joypad2_Count = &H0
    Case &H6000& To &H7FFF&
        If SpecialWrite6000 = True Then
            MapperWrite Address, value
        ElseIf UsesSRAM Then
            If Mapper <> 69 Then bank6(Address And &H1FFF) = value
        End If
    Case Else:
End Select

End Sub
Public Sub MMC3Write(value As Byte, Address As Long)
Select Case Address
    Case &H8000&
        MMC3_Command = value And &H7
        If value And &H80 Then MMC3_ChrAddr = &H1000& Else MMC3_ChrAddr = 0
        If value And &H40 Then swap = 1 Else swap = 0
    Case &H8001&
        Select Case MMC3_Command
            Case 0: Select1KVROM value, 0: Select1KVROM value + 1, 1
            Case 1: Select1KVROM value, 2: Select1KVROM value + 1, 3
            Case 2: Select1KVROM value, 4
            Case 3: Select1KVROM value, 5
            Case 4: Select1KVROM value, 6
            Case 5: Select1KVROM value, 7
            Case 6: PrgSwitch1 = value: MMC3_Sync
            Case 7: PrgSwitch2 = value: MMC3_Sync
        End Select
    Case &HA000&
        If value Then
            MirrorXor = &H400&
        Else
            MirrorXor = &H800&
        End If
    Case &HA001&: If value Then UsesSRAM = True Else UsesSRAM = False
    Case &HC000&: MMC3_IrqVal = value
    Case &HC001&: MMC3_TmpVal = value
    Case &HE000&: MMC3_IrqOn = False: MMC3_IrqVal = MMC3_TmpVal
    Case &HE001&: MMC3_IrqOn = True
End Select
End Sub
Public Function MMC3_HBlank(Scanline, two As Byte) As Boolean
    
    If Scanline = 0 Then
        MMC3_IrqVal = MMC3_TmpVal
        MMC3_HBlank = False
    ElseIf Scanline > 239 Then Exit Function
    ElseIf MMC3_IrqOn And (two And &H18) Then
        MMC3_IrqVal = MMC3_IrqVal - 1
        If (MMC3_IrqVal = 0) Then
            MMC3_HBlank = True
            MMC3_IrqVal = MMC3_TmpVal
        End If
    End If
    
End Function
Public Sub MapperWrite(Address As Long, value As Byte)
'===================================='
'       MapperWrite(Address,value)   '
' Selects/Switches Chr-ROM and Prg-  '
' ROM depending on the mapper. Based '
' on DarcNES.                        '
'===================================='
    Select Case Mapper
        Case 1: MMC1_Write Address, value
        Case 2
            reg8 = (value * 2)
            regA = reg8 + 1
            SetupBanks
        Case 3: Select8KVROM (value And AndIt)
        Case 4: MMC3Write value, Address ' this function is too big to store here...
        Case 7
            reg8 = 4 * (value And &HF)
            regA = reg8 + 1
            regC = reg8 + 2
            regE = reg8 + 3
            SetupBanks
            Mirroring = (value And &H10) \ 16 Xor 1
            If Mirroring Then MirrorXor = &H800& Else MirrorXor = &H0
        Case 8
            reg8 = value And &HF8
            regA = reg8 + 1
            SetupBanks
            Select8KVROM value And &H7
        Case 9, 10: MMC2Write Address, value
        Case 11
            reg8 = 4 * (value And &HF)
            regA = reg8 + 1
            regC = reg8 + 2
            regE = reg8 + 3
            SetupBanks
            Select8KVROM (value And &HF0)
        Case 15
            Map15_BankAddr = (value And &H3F)
            Select Case (Address And &H3)
                Case &H0
                    map15_swapaddr = (value And &H80)
                    reg8 = Map15_BankAddr
                    regA = Map15_BankAddr + 1
                    regC = Map15_BankAddr + 2
                    regE = Map15_BankAddr + 3
                    SetupBanks
                Case &H1
                    Map15_SwapReg = (value And &H80)
                    regC = Map15_BankAddr
                    regE = Map15_BankAddr + 1
                    SetupBanks
                Case &H2
                    
                Case &H3
                    Map15_SwapReg = (value And &H80)
                    regC = Map15_BankAddr
                    regE = Map15_BankAddr + 1
                    SetupBanks
                    Mirroring = (value And &H40) \ &H40 Xor 1
                    MirrorXor = Mirroring * &H400&
            End Select
        Case 16
            Select Case Address And &HD
                Case &H0 To &H7: Select1KVROM value, Address And &H7
                Case &H8: reg8 = value * 2: regA = reg8 + 1: SetupBanks
                Case &H9: Mirroring = value And &H3: MirrorXor = pow2(Mirroring + 10) '&H400& * pow2(Mirroring)
                Case &HA: MMC16_IrqOn = value
                Case &HB: 'Debug.Print value
                Case &HC: 'Debug.Print value
                Case &HD: ' ?
            End Select
        Case 32
            Select Case Address
                Case &H8000& To &H8FFF&
                    If (MMC32_Switch And &H2) = 2 Then
                        regC = value
                        SetupBanks
                    Else
                        reg8 = value
                        SetupBanks
                    End If
                'Debug.Print "address:$" & Hex$(Address) & " value:$" & Hex$(value)
                Case &H9000& To &H9FFF&
                    Mirroring = (value And &H1) Xor 1: MirrorXor = pow2(Mirroring + 10) '&H400& * pow2(Mirroring)
                    MMC32_Switch = value
                Case &HA000& To &HAFFF&
                    regA = value
                    SetupBanks
                Case &HBFF0& To &HBFF7
                    Select1KVROM value, Address And &H7
            End Select
        Case 33
            Select Case Address
                Case &H8000&: reg8 = value: SetupBanks
                Case &H8001&: regA = value: SetupBanks
                Case &H8002&: Select2KVROM value, 0
                Case &H8003&: Select2KVROM value, 2
                Case &HA000&: Select1KVROM value, 4
                Case &HA001&: Select1KVROM value, 5
                Case &HA002&: Select1KVROM value, 6
                Case &HA003&: Select1KVROM value, 7
                Case &HC000, &HC001, &HE000&
            End Select
        Case 34
            If Address >= &H6000& And Address <= &H7FFC& Then Exit Sub
            Select Case Address
                Case &H7FFD&
                    reg8 = 4 * (value)
                    regA = reg8 + 1
                    regC = regA + 1
                    regE = regC + 1
                    SetupBanks
                Case &H7FFE&
                    Debug.Print "Map34: Chr-ROM Select - $" & Hex$(value) & " at $0000"
                    MemCopy VRAM(0), VROM(value * &H1000&), &H1000&
                Case &H7FFF&
                    Debug.Print "Map34: Chr-ROM Select - $" & Hex$(value) & " at $1000"
                    MemCopy VRAM(&H1000&), VROM(value * &H1000&), &H1000&
                Case &H8000& To &HFFFF&
                    reg8 = 4 * (value)
                    regA = reg8 + 1
                    regC = regA + 1
                    regE = regC + 1
                    SetupBanks
            End Select
        Case 40
            Select Case (Address And &HE000&)
                Case &H8000&
                    Mapper40_IRQEnabled = 0
                    Mapper40_IRQCounter = 36
                Case &HA000&
                    ' IRQ enable
                    Mapper40_IRQEnabled = 1
                Case &HE000&
                    regC = value
                    SetupBanks
            End Select
        Case 66
            reg8 = 4 * (value And &HFFFFF0)
            regA = reg8 + 1
            regC = regA + 1
            regE = regC + 1
            SetupBanks
            Select8KVROM value And &H3
        Case 68
            Select Case Address
                Case &H8000&, &H9000&, &HA000&, &HB000&, &HC000&, &HD000&: Select2KVROM value, (Address - &H8000&) \ &H1000&
                Case &HE000&: MirrorXor = (value And &H3) * &H400&
                Case &HF000&: reg8 = (value * 2): regA = (value * 2) + 1: SetupBanks
            End Select
        Case 69
            Select Case Address
                Case &H8000&: reg8000 = value And &HF
                Case &HA000&
                    Select Case reg8000
                        Case 0 To 7: Select1KVROM value, reg8000
                        Case 8: value = MaskBankAddress(value): MemCopy bank6(0), gameImage(value * &H2000&), &H2000&
                        Case 9: reg8 = value
                        Case 10: regA = value
                        Case 11: regC = value
                        Case 12: MirrorXor = (value And &H3) * &H400&
                        Case 13: ' Not sure here either
                        Case 14, 15 ' Not sure about these.
                    End Select
            End Select
            SetupBanks
        Case 71
            Select Case Address
                Case &H8000& To &HBFFF&: ' Unknown
                Case &HC000& To &HFFFF&: reg8 = (value * 2): regA = (value * 2) + 1: SetupBanks
            End Select
        Case 78: MMC78_Write Address, value
        Case 91
            Select Case Address
                Case &H6000& To &H6FFF&
                    Select Case Address And &H3
                        Case 0: Select2KVROM value, 0
                        Case 1: Select2KVROM value, 1
                        Case 2: Select2KVROM value, 2
                        Case 3: Select2KVROM value, 3
                    End Select
                Case &H7000& To &H7FFB&
                    Select Case Address And &H1
                        Case 0
                            reg8 = value
                            SetupBanks
                        Case 1
                            regA = value
                            SetupBanks
                    End Select
            End Select
    End Select
End Sub
Public Function LoadNES(Filename As String) As Byte

'===================================='
'           LoadNES(filename)        '
' Used to Load the NES ROM/VROM to   '
' specified arrays, gameImage and    '
' VROM, then figures out what to do  '
' based on the mapper number.        '
'===================================='
Dim Header As String * 3

Dim i As Long
Dim ROMCtrl As Byte, ROMCtrl2 As Byte
Erase VRAM: Erase VROM: Erase gameImage: Erase bank8: Erase bankA
Erase bankC: Erase bankE: Erase bank0: Erase bank6
SpecialWrite6000 = False

If Dir$(Filename) = "" Then MsgBox "File Not Found.", vbCritical, "basicNES": LoadNES = 0: Exit Function

Close #1

PrgCount = 0: PrgCount2 = 0: ChrCount = 0: ChrCount2 = 0

Open Filename For Binary As #1
    Get #1, , Header
    If Header <> "NES" Then
        MsgBox "Invalid Header", vbCritical, "basicNES"
        LoadNES = 0
        Close #1
        Exit Function
    End If
    
    Get #1, 5, PrgCount: PrgCount2 = PrgCount
    Get #1, 6, ChrCount: ChrCount2 = ChrCount
    Debug.Print "[ " & PrgCount & " ] ROM Bank(s)"
    Debug.Print "[ " & ChrCount & " ] CHR Bank(s)"
    
    Get #1, 7, ROMCtrl
    Debug.Print "[ " & ROMCtrl & " ] ROM Control Byte #1"
    Get #1, 8, ROMCtrl2
    Debug.Print "[ " & ROMCtrl2 & " ] ROM Control Byte #2"
    
    Mapper = (ROMCtrl And &HF0) \ 16
    Mapper = Mapper + ROMCtrl2
    
    Debug.Print "[ " & Mapper & " ] Mapper"
    Trainer = ROMCtrl And &H4
    Mirroring = ROMCtrl And &H1
    FourScreen = ROMCtrl And &H8
    If ROMCtrl And &H2 Then UsesSRAM = True
    Debug.Print "Mirroring=" & Mirroring & " Trainer=" & Trainer & " FourScreen=" & FourScreen & " SRAM=" & UsesSRAM
    Dim PrgMark As Long
    PrgMark = (PrgCount2 * &H4000&) - 1
    
    If Trainer Then
        MsgBox "Error: Trainer not yet supported.", vbCritical, VERSION
        LoadNES = 0: Exit Function
    End If
    ReDim gameImage(PrgMark) As Byte
    Get #1, 17, gameImage

    ReDim VROM(ChrCount2 * &H2000&) As Byte
    PrgMark = &H4000& * PrgCount2 + 17
    If ChrCount2 Then
        Get #1, PrgMark, VROM
        AndIt = ChrCount - 1
    End If
    Select Case Mapper
        Case 0, 3
            Select8KVROM 0
            reg8 = 0: regA = 1: regC = &HFE: regE = &HFF
            SetupBanks
        Case 1
            Select8KVROM 0
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
            sequence = 0: accumulator = 0
            Erase data
            data(0) = &H1F: data(3) = 0
        Case 2
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 4
            swap = False
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            MMC3_Sync
            MMC3_IrqVal = 0: MMC3_IrqOn = False: MMC3_TmpVal = 0
            If ChrCount Then
                Select8KVROM 0
            End If
        Case 6
            swap = False
        Case 7
            reg8 = 0
            regA = 1
            regC = 2
            regE = 3
            SetupBanks
        Case 8 'FFE F3xxx
            reg8 = 0: regA = 1
            regC = &HFE: regE = &HFF
            SetupBanks
            Select8KVROM 0
        Case 9, 10 ' MMC2, MMC4
            reg8 = 0
            regA = &HFD
            regC = &HFE
            regE = &HFF
            SetupBanks
            latch1 = &HFE
            latch2 = &HFE
            Select8KVROM 0
        Case 11
            reg8 = 0: regA = 1: regC = 2: regE = 3
            SetupBanks
            Select8KVROM 0
        Case 15
            reg8 = 0
            regA = 1
            regC = 2
            regE = 3
            SetupBanks
        Case 16
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 32
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 33
            reg8 = 0
            regA = 1
            regC = &HFE
            regE = &HFF
            SetupBanks
        Case 34
            SpecialWrite6000 = True
            reg8 = 0
            regA = 1
            regC = 2
            regE = 3
            SetupBanks
            If ChrCount Then Select8KVROM 0
        Case 40 ' SMB2j [works!]
            Dim ChoseIt As Byte
            ChoseIt = 6
            ChoseIt = MaskBankAddress(ChoseIt)
            Debug.Print ChoseIt
            UsesSRAM = True
            MemCopy bank6(0), gameImage(ChoseIt * &H2000&), &H2000&
            reg8 = &HFC
            regA = &HFD
            regC = &HFE
            regE = &HFF
            SetupBanks
            Select8KVROM 0
            Mapper40_IRQEnabled = 0
            Mapper40_IRQCounter = 0
        Case 66
            reg8 = 0: regA = 1: regC = 2: regE = 3: SetupBanks
            Select8KVROM 0
            SetupBanks
        Case 68
            reg8 = 0: regA = 1: regC = &HFE: regE = &HFF
            Select8KVROM 0
            SetupBanks
            UsesSRAM = True
        Case 69
        Case 71
            reg8 = 0: regA = 1: regC = &HFE: regE = &HFF
            SetupBanks
        Case 78
            regC = &HFE
            regE = &HFF
            SetupBanks
            MMC78_Write 0, 0
        Case 91
            SpecialWrite6000 = True
            reg8 = &HFE
            regA = &HFF
            regC = &HFE
            regE = &HFF
            Select8KVROM 0
            SetupBanks
        Case Else
            MsgBox "Mapper #" & Mapper & " is not supported.", vbCritical, VERSION
            Erase gameImage: Erase VROM
            Close #1: LoadNES = 0: Exit Function
    End Select
    Debug.Print "Successfully loaded " & Filename
    reset6502
    If Mirroring = 1 Then MirrorXor = &H800& Else MirrorXor = &H400&
Close #1

CurrentLine = 0
For i = 0 To 7
    Joypad1(i) = &H40
Next i
For i = 0 To 7
    Joypad2(i) = &H40
Next i
Frames = 0
CPUPaused = False
ScrollToggle = 1
LoadNES = 1
End Function

Public Sub MMC17_SyncVROM(bank As Long)
    
    Dim value As Byte
    
    value = bank_regs(bank)
    value = value Or 16 * (bank_regs(bank + 1))
    
    Select1KVROM bank \ 2, value
    
End Sub
Public Sub MMC23_Write(Address As Long, value As Byte)
    Select Case Address
        Case &H8000&
            reg8 = value
            SetupBanks
        Case &H9000&
             MirrorXor = pow2((value And &H3) + 10) '&H400& * pow2(value And &H3)
        Case &HA000&
            regA = value
            SetupBanks
        'TODO: finish code...
    End Select
End Sub
Public Sub MMC78_Write(Address As Long, value As Byte)
    
    Dim vromptr As Byte, romptr As Byte
    
    vromptr = (value \ &H10&) And &HF
    romptr = value And &HF
    
    Select8KVROM vromptr
    reg8 = (romptr * 2)
    regA = (romptr * 2) + 1
    SetupBanks
    
End Sub
Public Sub MMC1_Write(Address As Long, value As Byte)

Dim bank_select As Long 'Integer

If (value And &H80) Then
    data(0) = data(0) Or &HC
    accumulator = data((Address \ &H2000&) And 3)
    sequence = 5
Else
    If value And 1 Then accumulator = accumulator Or pow2(sequence)
    sequence = sequence + 1
End If

If (sequence = 5) Then
    data(Address \ &H2000& And 3) = accumulator
    sequence = 0
    accumulator = 0

    MirrorXor = pow2((data(0) And &H3) + 10)
    
    If (PrgCount = &H20) Then '/* 512k cart */'
        bank_select = (data(1) And &H10) * 2
    Else '/* other carts */'
        bank_select = 0
    End If
    
    If data(0) And 2 Then
        Mirroring = (data(0) And 1) Xor 1
    Else
        Mirroring = 2
    End If
    
    If (data(0) And 8) = 0 Then
        reg8 = 4 * (data(3) And 15) + bank_select
        regA = 4 * (data(3) And 15) + bank_select + 1
        regC = 4 * (data(3) And 15) + bank_select + 2
        regE = 4 * (data(3) And 15) + bank_select + 3
        SetupBanks
    ElseIf (data(0) And 4) Then
        reg8 = ((data(3) And 15) * 2) + bank_select
        regA = ((data(3) And 15) * 2) + bank_select + 1
        regC = &HFE
        regE = &HFF
        SetupBanks
    Else
        reg8 = 0
        regA = 1
        regC = ((data(3) And 15) * 2) + bank_select
        regE = ((data(3) And 15) * 2) + bank_select + 1
        SetupBanks
    End If
    
    If (data(0) And &H10) Then
        Select4KVROM data(1), 0
        Select4KVROM data(2), 1
    Else
        Select8KVROM data(1) \ 2
    End If
End If

End Sub
Public Sub MMC2Write(Address As Long, value As Byte)
value = value And &HFF
Select Case (Address And &HF000&)
        Case &HA000&
            If Mapper = 9 Then
                reg8 = value
            ElseIf Mapper = 10 Then
                reg8 = value * 2
                regA = reg8 + 1
            End If
            SetupBanks
        Case &HB000&
            Latch0FD = value
            If latch1 = &HFD Then
                Select4KVROM value, 0
            End If
        Case &HC000&
            Latch0FE = value
            If latch1 = &HFE Then
                Select4KVROM value, 0
            End If
        Case &HD000&
            Latch1FD = value
            If latch2 = &HFD Then
                Select4KVROM value, 1
            End If
        Case &HE000&
            Latch1FE = value
            If latch2 = &HFE Then
                Select4KVROM value, 1
            End If
        Case &HF000&: Mirroring = IIf(value And &H1, False, True)
End Select
End Sub

Public Sub MMC2_latch(TileNum As Byte, Hi As Boolean)
If Mapper <> 9 Then Exit Sub
If (TileNum = 253) Then
    If (Hi = False) Then
        Select4KVROM Latch0FD, 0
        latch1 = &HFD
    ElseIf (Hi = True) Then
        Select4KVROM Latch1FD, 1
        latch2 = &HFD
    End If
ElseIf (TileNum = 254) Then
    If (Hi = False) Then
        Select4KVROM Latch0FE, 0
        latch1 = &HFE
    ElseIf (Hi = True) Then
        Select4KVROM Latch1FE, 1
        latch2 = &HFE
    End If
End If

End Sub
#If 0 Then 'Unused
Public Sub DrawScreenNES()
Dim Tile As Byte
Dim X2 As Integer, Y2 As Integer
Dim X1 As Integer, y1 As Integer
Dim X3 As Integer, Y3 As Integer
Dim Byte1 As Byte, Byte2 As Byte, Color As Integer, palette As Integer
Dim count As Integer
NameTable = &H2000& + (&H400& * (PPU_Control1 And &H3))
PatternTable = (PPU_Control1 And &H10) * &H100&
count = 0
For X1 = 0 To 29
    For y1 = 31 To 0 Step -1
        Tile = VRAM(NameTable + count)
        Dim Anded As Long
        For Y2 = 1 To 8
            Anded = pow2(Y2 - 1)
            For X2 = 1 To 8
                Byte1 = VRAM(PatternTable + 16 * (Tile) + X2)
                Byte2 = VRAM(PatternTable + 16 * (Tile) + X2 + 8)
                Color = 0
                If (Byte1 And Anded) Then Color = 1
                If (Byte2 And Anded) Then Color = Color + 2
                palette = ((VRAM((NameTable + &H3C0) + (((currow \ 4) * 8) + (curcol \ 4)))) \ pow2(((((currow And 2) + ((curcol \ 2) And 1))) * 2) And 6)) And 3
                frmNES.picScreen.PSet (255 - (y1 * 8 + Y2), X1 * 8 + X2), CPal(VRAM(&H3F00 + 4 * (palette) + c1) And &H3F)
            Next X2
        Next Y2
        count = count + 1
    Next y1
Next X1
DoEvents
frmNES.picScreen.Refresh
End Sub
#End If
'Tile based sprite renderer
Public Sub DrawSprites(ontop As Boolean)
If (PPU_Control2 And 16) = 0 Then Exit Sub
    Dim SpritePattern As Long 'Integer
    SpritePattern = (PPU_Control1 And &H8) * &H200&
    Dim spr As Long 'Integer
    Dim X1 As Long, y1 As Long
    Dim Byte1 As Byte, Byte2 As Byte
    Dim Color As Byte
    Dim sa As Long
    Dim h As Long
    Dim i As Long
    Dim x As Long, Y As Long, attrib As Long, tileno As Long, pal As Long, a As Long
    
    If PPU_Control1 And &H20 Then
        h = 16
    Else
        h = 8
    End If
    
    SpriteAddr = 0
    
    For spr = 63 To 0 Step -1
        SpriteAddr = 4 * spr
        attrib = SpriteRAM(SpriteAddr + 2)
        If (attrib And 32) = 0 Xor ontop Then
            x = SpriteRAM(SpriteAddr + 3)
            Y = SpriteRAM(SpriteAddr)
            If Y < 239 And x < 248 Then
                tileno = SpriteRAM(SpriteAddr + 1)
                If h = 16 Then
                    SpritePattern = (tileno And 1) * &H1000
                    tileno = tileno Xor (tileno And 1)
                End If
                sa = SpritePattern + 16 * tileno
                i = Y * 256& + x + 256
                pal = 16 + (attrib And 3) * 4
                
                If attrib And 128 Then
                    If attrib And 64 Then
                        For y1 = h - 1 To 0 Step -1
                            If y1 >= 8 Then
                                Byte1 = VRAM(sa + 8 + y1)
                                Byte2 = VRAM(sa + 16 + y1)
                            Else
                                Byte1 = VRAM(sa + y1)
                                Byte2 = VRAM(sa + y1 + 8)
                            End If
                            a = Byte1 * 2048& + Byte2 * 8
                            For X1 = 0 To 7
                                Color = tLook(X1 + a)
                                If Color Then vBuffer(i + X1) = Color Or pal
                            Next X1
                            i = i + 256
                            If i >= 256& * 240 Then Exit For
                        Next y1
                    Else
                        i = i + 7
                        For y1 = h - 1 To 0 Step -1
                            If y1 >= 8 Then
                                Byte1 = VRAM(sa + 8 + y1)
                                Byte2 = VRAM(sa + 16 + y1)
                            Else
                                Byte1 = VRAM(sa + y1)
                                Byte2 = VRAM(sa + y1 + 8)
                            End If
                            a = Byte1 * 2048& + Byte2 * 8
                            For X1 = 7 To 0 Step -1
                                Color = tLook(X1 + a)
                                If Color Then vBuffer(i - X1) = Color Or pal
                            Next X1
                            i = i + 256
                            If i >= 256& * 240 Then Exit For
                        Next y1
                    End If
                Else
                    If attrib And 64 Then
                        For y1 = 0 To h - 1
                            If y1 = 8 Then sa = sa + 8
                            Byte1 = VRAM(sa + y1)
                            Byte2 = VRAM(sa + y1 + 8)
                            a = Byte1 * 2048& + Byte2 * 8
                            For X1 = 0 To 7
                                Color = tLook(X1 + a)
                                If Color Then vBuffer(i + X1) = Color Or pal
                            Next X1
                            i = i + 256
                            If i >= 256& * 240 Then Exit For
                        Next y1
                    Else
                        i = i + 7
                        For y1 = 0 To h - 1
                            If y1 = 8 Then sa = sa + 8
                            Byte1 = VRAM(sa + y1)
                            Byte2 = VRAM(sa + y1 + 8)
                            a = Byte1 * 2048& + Byte2 * 8
                            For X1 = 7 To 0 Step -1
                                Color = tLook(X1 + a)
                                If Color Then vBuffer(i - X1) = Color Or pal
                            Next X1
                            i = i + 256
                            If i >= 256& * 240 Then Exit For
                        Next y1
                    End If
                End If
            End If
        End If
    Next spr
End Sub
#If 0 Then 'Unused
Public Sub DrawScreenQb()
Dim Tile As Byte
Dim X2 As Long, Y2 As Long
Dim X1 As Long, y1 As Long
Dim X3 As Long, Y3 As Long
Dim Byte1 As Byte, Byte2 As Byte, Color As Integer, palette As Integer
Dim count As Integer
NameTable = &H2000& + (&H400& * (PPU_Control1 And &H3))
PatternTable = (PPU_Control1 And &H10) * &H100&
count = 0
'If PPU_Control1 And &H8 = 0 Then Exit Sub
For X1 = 0 To 29
    For y1 = 31 To 0 Step -1
        Tile = VRAM(NameTable + count)
        Dim Anded As Long
        'If DirtyChar(count) Then
        For Y2 = 0 To 7
            For X2 = 0 To 7
                Byte1 = VRAM(PatternTable + 16 * (Tile) + X2)
                Byte2 = VRAM(PatternTable + 16 * (Tile) + X2 + 8)
                Color = 0
                If (Byte1 And pow2(Y2)) Then Color = 1
                If (Byte2 And pow2(Y2)) Then Color = Color + 2
                frmNES.picScreen.PSet (255 - (y1 * 8 + Y2), X1 * 8 + X2), QBColor(Color)
            Next X2
        Next Y2
        'End If
        'DirtyChar(count) = 0
        count = count + 1
    Next y1
Next X1
#If 0 Then
    DrawSprites
#End If
DoEvents
frmNES.picScreen.Refresh
End Sub
#End If
Public Sub LoadPal()
On Error Resume Next
Dim n As Long 'Integer
Dim r As Byte, g As Byte, b As Byte
Dim Buff2 As Long
Dim Buff3 As Long
Open App.Path & "\bnes.pal" For Binary As #75
For n = 0 To 63
    Get #75, , r
    Get #75, , g
    Get #75, , b
    pal(n) = RGB2(r, g, b)
    pal16(n) = rgb16(r, g, b)
    pal15(n) = rgb15(r, g, b)
    pal(n + 64) = pal(n) 'DF: saves us an and per pixel
    pal(n + 128) = pal(n)
    pal(n + 192) = pal(n)
    pal16(n + 64) = pal16(n)
    pal16(n + 128) = pal16(n)
    pal16(n + 192) = pal16(n)
    pal15(n + 64) = pal15(n)
    pal15(n + 128) = pal15(n)
    pal15(n + 192) = pal15(n)
Next n
Close #75
End Sub

'DF: had to reverse colors in palette for it to look right with new gfx.
'later changed for 16bit color, then back to 32bit
Function RGB2(ByVal b As Long, ByVal g As Long, ByVal r As Long) As Long
RGB2 = RGB(r, g, b)
End Function
Function rgb16(ByVal b As Long, ByVal g As Long, ByVal r As Long) As Long
    rgb16 = (r \ 8) + (g \ 4) * 32 + (b \ 8) * 2048
End Function
Function rgb15(ByVal b As Long, ByVal g As Long, ByVal r As Long) As Long
    rgb15 = (r \ 8) + (g \ 8) * 32 + (b \ 8) * 1024
End Function


#If 0 Then
Function SetPalette(PalNum) As Integer
Select Case PalNum
Case 2
CPal = Array( _
 &H686868, &H804000, &H800000, &H800040, &H800080, &H400080, &H80, &H55, _
    &H4040, &H5033, &H5000, &H5000, &H404000, &H0, &H0, &H0, _
    &H989898, &HC08000, &HC04040, &HC00080, &HC000C0, &H8000C0, &H2020C0, &H40C0, _
    &H8080, &H8055, &H8000, &H338033, &H808000, &H0, &H0, &H0, _
    &HD0D0D0, &HFFC040, &HFF8080, &HFF40C0, &HFF00FF, &HC040FF, &H5050FF, &H4080FF, _
    &HC0C0, &HC080, &HC000, &H55C055, &HC0C000, &H333333, &H0, &H0, _
    &HFFFFFF, &HFFFF80, &HFFC0C0, &HFF80FF, &HFF40FF, &HFF80FF, &H8080FF, &H80C0FF, _
    &H40FFFF, &H40FFC0, &H40FF40, &HAAFFAA, &HFFFF40, &H999999, &H0, &H0 _
)
Case 1
    '*** Alex Krasivsky's Palette ***'
    CPal = Array(RGB2(&H68, &H68, &H68), RGB2(&H0, &H40, &H80), RGB2(&H0, &H0, &H80), RGB2(&H40, &H0, &H80), _
    RGB2(&H80, &H0, &H80), RGB2(&H80, &H0, &H40), RGB2(&H80, &H0, &H0), RGB2(&H55, &H0, &H0), _
    RGB2(&H40, &H40, &H0), RGB2(&H33, &H50, &H0), RGB2(&H0, &H50, &H0), RGB2(&H0, &H50, &H0), _
    RGB2(&H0, &H40, &H40), RGB2(&H0, &H0, &H0), RGB2(&H0, &H0, &H0), RGB2(&H0, &H0, &H0), _
    RGB2(&H98, &H98, &H98), RGB2(&H0, &H80, &HC0), RGB2(&H40, &H40, &HC0), RGB2(&H80, &H0, &HC0), _
    RGB2(&HC0, &H0, &HC0), RGB2(&HC0, &H0, &H80), RGB2(&HC0, &H20, &H20), RGB2(&HC0, &H40, &H0), _
    RGB2(&H80, &H80, &H0), RGB2(&H55, &H80, &H0), RGB2(&H0, &H80, &H0), RGB2(&H33, &H80, &H33), _
    RGB2(&H0, &H80, &H80), RGB2(&H0, &H0, &H0), RGB2(&H0, &H0, &H0), RGB2(&H0, &H0, &H0), _
    RGB2(&HD0, &HD0, &HD0), RGB2(&H40, &HC0, &HFF), RGB2(&H80, &H80, &HFF), RGB2(&HC0, &H40, &HFF), _
    RGB2(&HFF, &H0, &HFF), RGB2(&HFF, &H40, &HC0), RGB2(&HFF, &H50, &H50), RGB2(&HFF, &H80, &H40), _
    RGB2(&HC0, &HC0, &H0), RGB2(&H80, &HC0, &H0), RGB2(&H0, &HC0, &H0), RGB2(&H55, &HC0, &H55), _
    RGB2(&H0, &HC0, &HC0), RGB2(&H33, &H33, &H33), RGB2(&H0, &H0, &H0), RGB2(&H0, &H0, &H0), _
    RGB2(&HFF, &HFF, &HFF), RGB2(&H80, &HFF, &HFF), RGB2(&HC0, &HC0, &HFF), RGB2(&HFF, &H80, &HFF), _
    RGB2(&HFF, &H40, &HFF), RGB2(&HFF, &H80, &HFF), RGB2(&HFF, &H80, &H80), RGB2(&HFF, &HC0, &H80), _
    RGB2(&HFF, &HFF, &H40), RGB2(&HC0, &HFF, &H40), RGB2(&H40, &HFF, &H40), RGB2(&HAA, &HFF, &HAA), _
    RGB2(&H40, &HFF, &HFF), RGB2(&H99, &H99, &H99), RGB2(&H0, &H0, &H0), RGB2(&H0, &H0, &H0))
SetPalette = 1
'Debug.Print "SetPalette() Successful"
Case 3
    ' Matt Conte's perfect palette
   CPal = Array(RGB2(&H7F, &H7F, &H7F), RGB2(&H0, &H0, &HBB), RGB2(&H37, &H0, &HBF), RGB2(&H84, &H0, &HA6), _
   RGB2(&HBB, &H0, &H6A), RGB2(&HB7, &H0, &H22), RGB2(&HB3, &H1E, &H0), RGB2(&H91, &H26, &H0), _
   RGB2(&H7B, &H2B, &H0), RGB2(&H0, &H44, &H0), RGB2(&H0, &H48, &HD), RGB2(&H0, &H59, &H48), _
   RGB2(&H0, &H48, &H91), RGB2(&H0, &H0, &H0), RGB2(&H5, &H5, &H5), RGB2(&H5, &H5, &H5), _
   RGB2(&HC8, &HC8, &HC8), RGB2(&H0, &H59, &HFF), RGB2(&H66, &H0, &HFF), RGB2(&HB7, &H33, &HCC), _
   RGB2(&HFF, &H33, &H8C), RGB2(&HFF, &H3C, &H5E), RGB2(&HFF, &H37, &H1A), RGB2(&HD5, &H4B, &H0), _
   RGB2(&HC4, &H62, &H0), RGB2(&H59, &H7B, &H0), RGB2(&H1E, &H84, &H15), RGB2(&H0, &H95, &H7B), _
   RGB2(&H0, &H99, &HD9), RGB2(&H11, &H11, &H11), RGB2(&H9, &H9, &H9), RGB2(&H9, &H9, &H9), _
   RGB2(&HFF, &HFF, &HFF), RGB2(&H0, &HAA, &HFF), RGB2(&H80, &H80, &HFF), RGB2(&HD5, &H6F, &HFF), _
   RGB2(&HFF, &H77, &HC4), RGB2(&HFF, &H77, &H99), RGB2(&HFF, &H7B, &H62), RGB2(&HFF, &H8C, &H59), _
   RGB2(&HFF, &HA2, &H2B), RGB2(&HBB, &HC8, &H0), RGB2(&H51, &HD9, &H6A), RGB2(&H4D, &HD5, &HAE), _
   RGB2(&H15, &HEA, &HFF), RGB2(&H66, &H66, &H66), RGB2(&HD, &HD, &HD), RGB2(&HD, &HD, &HD), _
   RGB2(&HFF, &HFF, &HFF), RGB2(&HAE, &HC8, &HFF), RGB2(&HBB, &HBB, &HFF), RGB2(&HDD, &HB3, &HEA), _
   RGB2(&HFF, &HB7, &HEA), RGB2(&HFF, &HB3, &HCC), RGB2(&HFF, &HC4, &HB7), RGB2(&HFF, &HCC, &HAE), _
   RGB2(&HFF, &HD9, &HA2), RGB2(&HCC, &HE1, &H99), RGB2(&HAE, &HEE, &HB7), RGB2(&HAA, &HF2, &HCC), _
   RGB2(&HA2, &HEE, &HFF), RGB2(&HDD, &HDD, &HDD), RGB2(&H11, &H11, &H11), RGB2(&H11, &H11, &H11))
   SetPalette = 1
End Select
End Function
#End If
