Attribute VB_Name = "M6502AddrModes"
Option Explicit

DefLng A-Z


' M6502 CPU Implementation for basicNES 2000.
' By Don Jarrett and Tobias Strmstedt, 1997-2000
' If you use this file commercially please drop me a mail
' at r.jarrett@worldnet.att.net or d.jarrett@worldnet.att.net.
' basicNES Copyright (C) 1996-2000 Don Jarrett.

Public Const APPLE2_INCLUDE = 0

Public CurrentLine As Long 'Integer
Public AddressMask As Long 'Integer

'Registers and tempregisters
'DF: Be careful. Anything, anywhere that uses a variable of the same name without declaring it will be using these:
Public a As Byte
Public x As Byte
Public Y As Byte
Public S As Byte
Public p As Byte

'32bit instructions are faster in protected mode than 16bit
Public PC As Long
Public savepc As Long
Public value As Long 'Integer
Public value2 As Long 'Integer
Public sum As Long 'Integer
Public saveflags As Long 'Integer
Public help As Long

Public opcode As Byte
Public clockticks6502 As Long

' arrays
Public Ticks(0 To 256) As Byte
Public addrmode(0 To 256) As Byte
Public instruction(0 To 256) As Byte
Public gameImage() As Byte

Public CPUPaused As Boolean

Public addrmodeBase As Long

Public maxCycles1 As Long 'max cycles per scanline from scanlines 0-239
Public maxCycles As Long 'max cycles until next scanline
Public SmartExec As Boolean
Public realframes As Long 'actual # of frames rendered

Public autospeed As Boolean


Public Sub implied6502()

  
End Sub
Public Sub indabsx6502()
  help = Read6502(PC) + (Read6502(PC + 1) * &H100&) + x
  savepc = Read6502(help) + (Read6502(help + 1) * &H100&)
End Sub
Public Sub indx6502()
'TS: Changed PC++ and removed ' (?)
  value = Read6502(PC) And &HFF
  value = (value + x) And &HFF
  PC = PC + 1
  savepc = Read6502(value) + (Read6502(value + 1) * &H100&)
End Sub
Public Sub indy6502()
'TS: Changed PC++ and == to != (If then else)
  value = Read6502(PC)
  PC = PC + 1
      
  savepc = Read6502(value) + (Read6502(value + 1) * &H100&)
  If (Ticks(opcode) = 5) Then
    If ((savepc \ 256) = ((savepc + Y) \ 256)) Then
    Else
      clockticks6502 = clockticks6502 + 1
    End If
  End If
  savepc = savepc + Y
End Sub

Public Sub zpx6502()
'TS: Rewrote everything!
'Overflow stupid check
  savepc = Read6502(PC)
  savepc = savepc + x
  PC = PC + 1
  'savepc = savepc And &HFF
End Sub

Public Sub exec6502()
  Dim f As Long
  f = Frames
  While Frames = f And CPURunning
  If CPUPaused = True Then
    Do Until CPUPaused = False
        DoEvents
    Loop
  End If
  opcode = Read6502(PC)  ' Fetch Next Operation
  PC = PC + 1
  clockticks6502 = clockticks6502 + Ticks(opcode)

Select Case instruction(opcode)
    Case INS_BNE: bne6502
    Case INS_CMP: cmp6502
    Case INS_LDA: lda6502
    Case INS_STA: sta6502
    Case INS_BIT: bit6502
    Case INS_BVC: bvc6502
    Case INS_BEQ: beq6502
    Case INS_INY: iny6502
    Case INS_BPL: bpl6502
    Case INS_DEX: dex6502
    Case INS_INC: inc6502
    Case INS_JMP: jmp6502
    Case INS_DEC: dec6502
    Case INS_JSR: jsr6502
    Case INS_AND: and6502
    Case INS_NOP:
    
    Case INS_BRK: brk6502
    Case INS_ADC: adc6502
    Case INS_EOR: eor6502
    Case INS_ASL: asl6502
    Case INS_ASLA: asla6502
    Case INS_BCC: bcc6502
    Case INS_BCS: bcs6502
    Case INS_BMI: bmi6502
    Case INS_BVS: bvs6502
    Case INS_CLC: p = p And &HFE
    Case INS_CLD: p = p And &HF7
    Case INS_CLI: p = p And &HFB
    Case INS_CLV: p = p And &HBF
    Case INS_CPX: cpx6502
    Case INS_CPY: cpy6502
    Case INS_DEA: dea6502
    Case INS_DEY: dey6502
    Case INS_INA: ina6502
    Case INS_INX: inx6502
    Case INS_LDX: ldx6502
    Case INS_LDY: ldy6502
    Case INS_LSR: lsr6502
    Case INS_LSRA: lsra6502
    Case INS_ORA: ora6502
    Case INS_PHA: pha6502
    Case INS_PHX: phx6502
    Case INS_PHP: php6502
    Case INS_PHY: phy6502
    Case INS_PLA: pla6502
    Case INS_PLP: plp6502
    Case INS_PLX: plx6502
    Case INS_PLY: ply6502
    Case INS_ROL: rol6502
    Case INS_ROLA: rola6502
    Case INS_ROR: ror6502
    Case INS_RORA: rora6502
    Case INS_RTI: rti6502
    Case INS_RTS: rts6502
    Case INS_SBC: sbc6502
    Case INS_SEC: p = p Or &H1
    Case INS_SED: p = p Or &H8
    Case INS_SEI: p = p Or &H4
    Case INS_STX: stx6502
    Case INS_STY: sty6502
    Case INS_TAX: tax6502
    Case INS_TAY: tay6502
    Case INS_TXA: txa6502
    Case INS_TYA: tya6502
    Case INS_TXS: txs6502
    Case INS_TSX: tsx6502
    Case INS_BRA: bra6502
    Case Else: MsgBox "Invalid opcode - " & Hex$(opcode)
End Select
  
  If clockticks6502 > maxCycles Then
        CurrentLine = CurrentLine + 1
        RenderScanline CurrentLine 'moved frame skip check into renderscanline
        If Mapper = 4 Then
            If MMC3_HBlank(CurrentLine, PPU_Control1) = True Then irq6502
        End If
        If CurrentLine >= 240 Then
            If CurrentLine = 240 Then
                If render Then
                    blitScreen
                End If
                Frames = Frames + 1
                If render Then realframes = realframes + 1
                DoEvents 'ensure most recent keyboard input
            End If
            PPU_Status = &H80
            
            ' Modified to support key mapping! By Factor-1
            ' Added Joypad2
            Joypad1(0) = Keyboard(frmKeys.txtA.Text) 'A
            Joypad1(1) = Keyboard(frmKeys.txtB.Text) 'B
            Joypad1(2) = Keyboard(frmKeys.txtSelect.Text) 'Sl
            Joypad1(3) = Keyboard(frmKeys.txtStart.Text)
            
            Joypad1(4) = Keyboard(38)
            Joypad1(5) = Keyboard(40)
            Joypad1(6) = Keyboard(37)
            Joypad1(7) = Keyboard(39)
            
            Joypad2(0) = Keyboard(frmKeys.txtA2.Text)
            Joypad2(1) = Keyboard(frmKeys.txtB2.Text)
            Joypad2(2) = Keyboard(frmKeys.txtSelect2.Text)
            Joypad2(3) = Keyboard(frmKeys.txtStart2.Text)
            
            Joypad2(4) = Keyboard(38)
            Joypad2(5) = Keyboard(40)
            Joypad2(6) = Keyboard(37)
            Joypad2(7) = Keyboard(39)
            
            If CurrentLine = 240 Then If (PPU_Control1 And &H80) Then nmi6502
            If Mapper = 40 Then
                If Mapper40_IRQEnabled = 1 Then
                    Mapper40_IRQCounter = (Mapper40_IRQCounter - 1) And 36
                    If Mapper40_IRQCounter = 0 Then irq6502
                End If
            End If
        End If
        
        If CurrentLine = 262 Then
            updateSounds
            'DF: repaint now when currentline=240
            
            CurrentLine = 0
            
            'DF: delays if too fast, skips frames if too slow.
            If autospeed Then
                Dim delay As Long, ti As Long, ti2 As Long
                Static tmr As Double
                Static ptime As Double
                Static facc As Double
                Static pframe As Long
                Dim tme As Double
                tme = Timer
                If tme - ptime < 0.2 Then
                    tmr = tmr - tme + ptime
                End If
                tmr = tmr + 0.01667
                ptime = tme
                
                render = True
                If tmr < 0 Then
                    If tmr < -0.5 Then
                        If tmr < -1.25 Then tmr = -1.25
                        facc = facc + 0.5 - tmr
                        If facc > 1 Then render = False: facc = facc - 1
                    End If
                Else
                    delay = 10000 * tmr * tmr
                    For ti = 0 To delay
                        For ti2 = 0 To 1000
                            vBuffer32(ti And 255) = ti2 'slow things down
                        Next ti2
                    Next ti
                End If
                If Frames - pframe > 6 Then render = True
                If render Then
                    pframe = Frames
                End If
            Else
                render = (Frames Mod FrameSkip = 0)
            End If
            
            PPU_Status = &H0
        End If
        clockticks6502 = clockticks6502 - maxCycles
        If Not SmartExec Then
            If CurrentLine < 218 Or CurrentLine > 240 Then
                maxCycles = maxCycles1
            Else
                maxCycles = 114
            End If
        End If
  End If
  Wend
End Sub
Public Sub indzp6502()
'Added pc=pc+1, and (value+1) (Why Don?)
  value = Read6502(PC)
  PC = PC + 1
  savepc = Read6502(value) + (Read6502(value + 1) * &H100&)
End Sub

Public Sub zpy6502()
'TS: Added PC=PC+1
      savepc = Read6502(PC)
      savepc = savepc + Y
      PC = PC + 1
      'savepc = savepc And &HFF
End Sub

Public Sub absy6502()
'TS: Changed to != instead of == (Look at absx for more details)
  savepc = Read6502(PC) + (Read6502(PC + 1) * &H100&)
  PC = PC + 2

  If (Ticks(opcode) = 4) Then
    If ((savepc \ 256) = ((savepc + Y) \ 256)) Then
    Else
      clockticks6502 = clockticks6502 + 1
    End If
  End If
  savepc = savepc + Y
End Sub
Public Sub immediate6502()
  savepc = PC
  PC = PC + 1
End Sub
Public Sub indirect6502()
  help = Read6502(PC) + (Read6502(PC + 1) * &H100&)
  savepc = Read6502(help) + (Read6502(help + 1) * &H100&)
  PC = PC + 2
End Sub

Public Sub absx6502()
'TS: Changed to if then else instead of if then (!= instead of ==)
  savepc = Read6502(PC)
  savepc = savepc + (Read6502(PC + 1) * &H100&)
  PC = PC + 2

  If (Ticks(opcode) = 4) Then
    If ((savepc \ 256) = ((savepc + x) \ &H100&)) Then
    Else
      clockticks6502 = clockticks6502 + 1
    End If
  End If
  savepc = savepc + x
End Sub
Public Sub abs6502()
  savepc = Read6502(PC) + (Read6502(PC + 1) * &H100&)
  PC = PC + 2
End Sub
Public Sub relative6502()
'Changed to PC++ and == to != (If then else)
  
  savepc = Read6502(PC)
  PC = PC + 1

  If (savepc And &H80) Then savepc = savepc - &H100&

End Sub

Public Sub reset6502()
  a = 0: x = 0: Y = 0: p = &H22
  S = &HFF
  
  PC = Read6502(&HFFFC&) + (Read6502(&HFFFD&) * &H100&)
  Debug.Print "Reset to $" & Hex$(PC) & "[" & PC & "]"
End Sub

Public Sub zp6502()
  savepc = Read6502(PC)
  PC = PC + 1
End Sub

Public Sub irq6502()
   ' Maskable interrupt
   If (p And &H4) = 0 Then
    Write6502 &H100 + S, PC \ 256
    S = (S - 1) And &HFF
    Write6502 &H100 + S, (PC And &HFF)
    S = (S - 1) And &HFF
    Write6502 &H100 + S, p
    S = (S - 1) And &HFF
    p = p Or &H4
    PC = Read6502(&HFFFE&) + (Read6502(&HFFFF&) * &H100&)
    clockticks6502 = clockticks6502 + 7
   End If
End Sub

Public Sub nmi6502()
'TS: Changed PC>>8 to / not *
  Write6502 (S + &H100), (PC \ 256)
  S = (S - 1) And &HFF
  Write6502 (S + &H100), (PC And &HFF)
  S = (S - 1) And &HFF
  Write6502 (S + &H100), p
  p = p Or &H4
  S = (S - 1) And &HFF
  PC = Read6502(&HFFFA&) + (Read6502(&HFFFB&) * &H100&)
  'Debug.Print "nmi=" & PC & "[$" & Hex$(PC) & "]"
  clockticks6502 = clockticks6502 + 7
End Sub
