Attribute VB_Name = "m6502Instruct"
Option Explicit

DefLng A-Z


' This is where all 6502 instructions are kept.
Public Sub adc6502()
    Dim tmp As Long ' Integer
      
    adrmode opcode
    value = Read6502(savepc)
     
    saveflags = (p And &H1)
    'Debug.Print "adc6502"
    sum = a
    sum = (sum + value) And &HFF
    sum = (sum + saveflags) And &HFF
      
    If (sum > &H7F) Or (sum < -&H80) Then
        p = p Or &H40
    Else
        p = (p And &HBF)
    End If
      
    sum = a + (value + saveflags)
    If (sum > &HFF) Then
        p = p Or &H1
    Else
        p = (p And &HFE)
    End If
      
    a = sum And &HFF
    If (p And &H8) Then
        p = (p And &HFE)
        If ((a And &HF) > &H9) Then
            a = (a + &H6) And &HFF
        End If
        If ((a And &HF0) > &H90) Then
            a = (a + &H60) And &HFF
            p = p Or &H1
        End If
    Else
        clockticks6502 = clockticks6502 + 1
    End If
    If (a) Then
        p = (p And &HFD)
    Else
        p = p Or &H2
    End If
    If (a And &H80) Then
        p = p Or &H80
    Else
        p = (p And &H7F)
    End If
End Sub

Public Sub adrmode(opcode As Byte)
Select Case addrmode(opcode)
    Case ADR_ABS: abs6502
    Case ADR_ABSX: absx6502
    Case ADR_ABSY: absy6502
    Case ADR_IMP: ' nothing really necessary cause implied6502 = ""
    Case ADR_IMM: savepc = pc: pc = pc + 1
    Case ADR_INDABSX: indabsx6502
    Case ADR_IND: indirect6502
    Case ADR_INDX: indx6502
    Case ADR_INDY: indy6502
    Case ADR_INDZP: indzp6502
    Case ADR_REL: savepc = Read6502(pc): pc = pc + 1: If (savepc And &H80) Then savepc = savepc - &H100&
    Case ADR_ZP: savepc = Read6502(pc): pc = pc + 1
    Case ADR_ZPX: zpx6502
    Case ADR_ZPY: zpy6502
    Case Else: Debug.Print addrmode(opcode)
End Select
End Sub

Public Sub and6502()
  adrmode opcode
  value = Read6502(savepc)
  a = (a And value)
  If (a) Then
    p = (p And &HFD)
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = (p And &H7F)
  End If
End Sub
Public Sub asl6502()
  adrmode opcode
  value = Read6502(savepc)
  
  p = (p And &HFE) Or ((value \ 128) And &H1)
  value = (value * 2) And &HFF
  
  Write6502 savepc, (value And &HFF)
  
  If (value) Then
    p = (p And &HFD)
  Else
    p = p Or &H2
  End If
  If (value And &H80) Then
    p = p Or &H80
  Else
    p = (p And &H7F)
  End If
End Sub


Public Sub asla6502()
  p = (p And &HFE) Or ((a \ 128) And &H1)
  a = (a * 2) And &HFF
  
  If (a) Then
    p = (p And &HFD)
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = (p And &H7F)
  End If
End Sub

Public Sub bcc6502()
  If ((p And &H1) = 0) Then
    adrmode opcode
    pc = pc + savepc
    clockticks6502 = clockticks6502 + 1
  Else
    pc = pc + 1
  End If
End Sub

Public Sub bcs6502()
  If (p And &H1) Then
    adrmode opcode
    pc = pc + savepc
    clockticks6502 = clockticks6502 + 1
  Else
    pc = pc + 1
  End If
End Sub

Public Sub beq6502()
  If (p And &H2) Then
    adrmode opcode
    pc = pc + savepc
    clockticks6502 = clockticks6502 + 1
  Else
    pc = pc + 1
  End If
End Sub

Public Sub bit6502()
  adrmode opcode
  value = Read6502(savepc)
  
  If (value And a) Then
    p = (p And &HFD)
    Else
    p = p Or &H2
  End If
  p = ((p And &H3F) Or (value And &HC0))
End Sub

Public Sub bmi6502()
  If (p And &H80) Then
    adrmode opcode
    pc = pc + savepc
    clockticks6502 = clockticks6502 + 1
  Else
    pc = pc + 1
  End If
End Sub

Public Sub bne6502()
  If ((p And &H2) = 0) Then
    adrmode opcode
    pc = pc + savepc
  Else
    pc = pc + 1
  End If
End Sub

Public Sub bpl6502()
  If ((p And &H80) = 0) Then
    adrmode opcode
    pc = pc + savepc
  Else
    pc = pc + 1
  End If
End Sub

Public Sub brk6502()
  pc = pc + 1
  Write6502 &H100 + S, (pc \ 256) And &HFF
  S = (S - 1) And &HFF
  Write6502 &H100 + S, (pc And &HFF)
  S = (S - 1) And &HFF
  Write6502 &H100 + S, p
  S = (S - 1) And &HFF
  p = p Or &H14
  pc = Read6502(&HFFFE&) + (Read6502(&HFFFF&) * &H100&)
End Sub

Public Sub bvc6502()
  If ((p And &H40) = 0) Then
    adrmode opcode
    pc = pc + savepc
    clockticks6502 = clockticks6502 + 1
  Else
    pc = pc + 1
  End If
End Sub

Public Sub bvs6502()
  If (p And &H40) Then
    adrmode opcode
    pc = pc + savepc
    clockticks6502 = clockticks6502 + 1
  Else
    pc = pc + 1
  End If
End Sub

Public Sub clc6502()
  p = p And &HFE
End Sub

Public Sub cld6502()
  p = p And &HF7
End Sub

Public Sub cli6502()
  p = p And &HFB
End Sub

Public Sub clv6502()
  p = p And &HBF
End Sub

Public Sub cmp6502()
  adrmode opcode
  value = Read6502(savepc)
  
  If (a + &H100 - value) > &HFF Then
    p = p Or &H1
  Else
    p = (p And &HFE)
  End If
  
  value = (a + &H100 - value) And &HFF
  If (value) Then
      p = (p And &HFD)
  Else
      p = (p Or &H2)
  End If
  If (value And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub

Public Sub cpx6502()
  adrmode opcode
  value = Read6502(savepc)
      
  If (x + &H100 - value > &HFF) Then
    p = p Or &H1
  Else
    p = (p And &HFE)
  End If
  
  value = (x + &H100 - value) And &HFF
  If (value) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  
  If (value And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub

Public Sub cpy6502()
  adrmode opcode
  value = Read6502(savepc)
      
  If (Y + &H100 - value > &HFF) Then
    p = (p Or &H1)
  Else
    p = (p And &HFE)
  End If
    value = (Y + &H100 - value) And &HFF
  If (value) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If (value And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub

Public Sub dec6502()
  adrmode opcode
      
  Write6502 (savepc), (Read6502(savepc) - 1) And &HFF
      
  value = Read6502(savepc)
  If (value) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If (value And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub
Public Sub dex6502()
  x = (x - 1) And &HFF
  If (x) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If (x And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub

Public Sub dey6502()
  Y = (Y - 1) And &HFF
      
  If (Y) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If (Y And &H80) Then
    p = p Or &H80
  Else
    p = (p And &H7F)
  End If
End Sub

Public Sub eor6502()
  adrmode opcode
  a = a Xor Read6502(savepc)
  
  If (a) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If (a And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub

Public Sub inc6502()
  adrmode opcode
  Write6502 (savepc), (Read6502(savepc) + 1) And &HFF
  
  value = Read6502(savepc)
  
  If (value) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If (value And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub

Public Sub inx6502()
  x = (x + 1) And &HFF
      
  If (x) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If (x And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub

Public Sub iny6502()
  Y = (Y + 1) And &HFF
  If (Y) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If (Y And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub
Public Sub jmp6502()
  adrmode opcode
  pc = savepc
End Sub
Public Sub jsr6502()
  pc = pc + 1
  Write6502 S + &H100, (pc \ 256)
  S = (S - 1) And &HFF
  Write6502 S + &H100, (pc And &HFF)
  S = (S - 1) And &HFF
  pc = pc - 1
  adrmode opcode
  pc = savepc
End Sub
Public Sub lda6502()
  adrmode opcode
  
  a = Read6502(savepc)
  
  If (a) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub ldx6502()
  adrmode opcode
  x = Read6502(savepc)
      
  If (x) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If (x And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub
Public Sub ldy6502()
  adrmode opcode
  Y = Read6502(savepc)
  
  If (Y) Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If (Y And &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub
Public Sub lsr6502()
  adrmode opcode
  value = Read6502(savepc)
         
  p = ((p And &HFE) Or (value And &H1))
  
  value = (value \ 2) And &HFF
  Write6502 savepc, (value And &HFF)
  
  If value Then
    p = (p And &HFD)
  Else
    p = (p Or &H2)
  End If
  If ((value And &H80) = &H80) Then
    p = (p Or &H80)
  Else
    p = (p And &H7F)
  End If
End Sub
Public Sub lsra6502()
  p = (p And &HFE) Or (a And &H1)
  a = (a \ 2) And &HFF
  If (a) Then
    p = (p And &HFD)
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub nop6502()
'TS: Implemented complex code structure ;)
End Sub
Public Sub ora6502()
  adrmode opcode
  a = a Or Read6502(savepc)
      
  If (a) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub pha6502()
  Write6502 &H100& + S, a
  S = (S - 1) And &HFF
End Sub
Public Sub php6502()
  Write6502 &H100& + S, p
  S = (S - 1) And &HFF
End Sub
Public Sub pla6502()
  S = (S + 1) And &HFF
  a = Read6502(S + &H100)
  If (a) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub plp6502()
  S = (S + 1) And &HFF
  p = Read6502(S + &H100) Or &H20
End Sub
Public Sub rol6502()
  saveflags = (p And &H1)
  adrmode opcode
  value = Read6502(savepc)
      
  p = (p And &HFE) Or ((value \ 128) And &H1)
  
  value = (value * 2) And &HFF
  value = value Or saveflags
  
  Write6502 savepc, (value And &HFF)
  
  If (value) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (value And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub rola6502()
  saveflags = (p And &H1)
  p = (p And &HFE) Or ((a \ 128) And &H1)
  a = (a * 2) And &HFF
  a = a Or saveflags
  If (a) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub ror6502()
  saveflags = (p And &H1)
  adrmode opcode
  value = Read6502(savepc)
      
  p = (p And &HFE) Or (value And &H1)
  value = (value \ 2) And &HFF
  If (saveflags) Then
    value = value Or &H80
  End If
  Write6502 (savepc), value And &HFF
  If (value) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (value And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub rora6502()
  saveflags = (p And &H1)
  p = (p And &HFE) Or (a And &H1)
  a = (a \ 2) And &HFF
  
  If (saveflags) Then
    a = a Or &H80
  End If
  If (a) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub rti6502()
  S = (S + 1) And &HFF
  p = Read6502(S + &H100) Or &H20
  S = (S + 1) And &HFF
  pc = Read6502(S + &H100)
  S = (S + 1) And &HFF
  pc = pc + (Read6502(S + &H100) * &H100&)
End Sub

Public Sub rts6502()
  S = (S + 1) And &HFF
  pc = Read6502(S + &H100)
  S = (S + 1) And &HFF
  pc = pc + (Read6502(S + &H100) * &H100&)
  pc = pc + 1
End Sub

Public Sub sbc6502()
  adrmode opcode
  value = Read6502(savepc) Xor &HFF
  
  saveflags = (p And &H1)
  
  sum = a
  sum = (sum + value) And &HFF
  sum = (sum + (saveflags * 16)) And &HFF
  
  If ((sum > &H7F) Or (sum <= -&H80)) Then
    p = p Or &H40
  Else
    p = p And &HBF
  End If
  
  sum = a + (value + saveflags)
  
  If (sum > &HFF) Then
    p = p Or &H1
  Else
    p = p And &HFE
  End If
  
  a = sum And &HFF
  If (p And &H8) Then
        a = (a - &H66) And &HFF
        p = p And &HFE
    If ((a And &HF) > &H9) Then
      a = (a + &H6) And &HFF
    End If
    If ((a And &HF0) > &H90) Then
      a = (a + &H60) And &HFF
      p = p Or &H1
    End If
  Else
    clockticks6502 = clockticks6502 + 1
  End If
  'Debug.Print "sbc6502"
  If (a) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub sec6502()
  p = p Or &H1
End Sub
Public Sub sed6502()
  p = p Or &H8
End Sub
Public Sub sei6502()
  p = p Or &H4
End Sub
Public Sub sta6502()
  adrmode opcode
  Write6502 (savepc), a
End Sub
Public Sub stx6502()
  adrmode opcode
  Write6502 (savepc), x
End Sub
Public Sub sty6502()
  adrmode opcode
  Write6502 (savepc), Y
End Sub
Public Sub tax6502()
  x = a
  If (x) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (x And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub

Public Sub tay6502()
  Y = a
  If (Y) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (Y And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub tsx6502()
  x = S
  If (x) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (x And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub

Public Sub txa6502()
  a = x
  If (a) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub txs6502()
  S = x
End Sub

Public Sub tya6502()
  a = Y
  If (a) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub bra6502()
  adrmode opcode
  pc = pc + savepc
  clockticks6502 = clockticks6502 + 1
End Sub
Public Sub dea6502()
  a = (a - 1) And &HFF
  
  If (a) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub ina6502()
  a = (a + 1) And &HFF
      
  If (a) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (a And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub phx6502()
  Write6502 &H100 + S, x
  S = (S - 1) And &HFF
End Sub

Public Sub plx6502()
  S = (S + 1) And &HFF
  x = Read6502(S + &H100)
  If (x) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (x And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
Public Sub phy6502()
  Write6502 &H100 + S, Y
  S = (S - 1) And &HFF
End Sub
Public Sub ply6502()
  S = (S + 1) And &HFF
  
  Y = Read6502(S + &H100)
  If (Y) Then
    p = p And &HFD
  Else
    p = p Or &H2
  End If
  If (Y And &H80) Then
    p = p Or &H80
  Else
    p = p And &H7F
  End If
End Sub
